// $ANTLR 3.3 Nov 30, 2010 12:45:30 ExprGrammar.g 2012-09-07 18:40:53

    package  fr.unicaen.openmap.dataStorage.expr;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
public class ExprGrammarParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "LBRACE", "RBRACE", "LPAREN", "RPAREN", "DOT", "SEMIC", "COMMA", "LT", "GT", "LTE", "GTE", "EQ", "NEQ", "NOTEQ", "ADD", "SUB", "MUL", "MOD", "AND", "OR", "XOR", "INV", "DIV", "ARGS", "LIST", "NEG", "POS", "DATACOLUMNNAME", "OMCOLUMNNAME", "TRUE", "FALSE", "INT", "FLOAT", "FUNCTION_CLASSIF_NO_CLASS_NUMBER", "FUNCTION_CLASSIF", "FUNCTION_CLASSIF_CUSTOM", "FUNCTION_N_TO_N", "FUNCTION_N1OR2_TO_N", "FUNCTION_G_TO_N", "FUNCTION_G_G_TO_N", "FUNCTION_S_TO_N", "FUNCTION_S_S_TO_N", "IF", "FUNCTION_N_N_TO_G", "FUNCTION_G_TO_G", "FUNCTION_G_N_TO_G", "FUNCTION_G_N_N_TO_G", "FUNCTION_G_G_TO_G", "STRING", "FUNCTION_S_SPLUS_TO_S", "FUNCTION_N_SPLUS_TO_S", "FUNCTION_S_N1OR2_TO_S", "FUNCTION_S_TO_S", "NOT", "LAND", "LOR", "Letter", "JavaIDDigit", "ID", "EXPONENT", "COMMENT", "WS", "ESC_SEQ", "HEX_DIGIT", "UNICODE_ESC", "OCTAL_ESC"
    };
    public static final int EOF=-1;
    public static final int LBRACE=4;
    public static final int RBRACE=5;
    public static final int LPAREN=6;
    public static final int RPAREN=7;
    public static final int DOT=8;
    public static final int SEMIC=9;
    public static final int COMMA=10;
    public static final int LT=11;
    public static final int GT=12;
    public static final int LTE=13;
    public static final int GTE=14;
    public static final int EQ=15;
    public static final int NEQ=16;
    public static final int NOTEQ=17;
    public static final int ADD=18;
    public static final int SUB=19;
    public static final int MUL=20;
    public static final int MOD=21;
    public static final int AND=22;
    public static final int OR=23;
    public static final int XOR=24;
    public static final int INV=25;
    public static final int DIV=26;
    public static final int ARGS=27;
    public static final int LIST=28;
    public static final int NEG=29;
    public static final int POS=30;
    public static final int DATACOLUMNNAME=31;
    public static final int OMCOLUMNNAME=32;
    public static final int TRUE=33;
    public static final int FALSE=34;
    public static final int INT=35;
    public static final int FLOAT=36;
    public static final int FUNCTION_CLASSIF_NO_CLASS_NUMBER=37;
    public static final int FUNCTION_CLASSIF=38;
    public static final int FUNCTION_CLASSIF_CUSTOM=39;
    public static final int FUNCTION_N_TO_N=40;
    public static final int FUNCTION_N1OR2_TO_N=41;
    public static final int FUNCTION_G_TO_N=42;
    public static final int FUNCTION_G_G_TO_N=43;
    public static final int FUNCTION_S_TO_N=44;
    public static final int FUNCTION_S_S_TO_N=45;
    public static final int IF=46;
    public static final int FUNCTION_N_N_TO_G=47;
    public static final int FUNCTION_G_TO_G=48;
    public static final int FUNCTION_G_N_TO_G=49;
    public static final int FUNCTION_G_N_N_TO_G=50;
    public static final int FUNCTION_G_G_TO_G=51;
    public static final int STRING=52;
    public static final int FUNCTION_S_SPLUS_TO_S=53;
    public static final int FUNCTION_N_SPLUS_TO_S=54;
    public static final int FUNCTION_S_N1OR2_TO_S=55;
    public static final int FUNCTION_S_TO_S=56;
    public static final int NOT=57;
    public static final int LAND=58;
    public static final int LOR=59;
    public static final int Letter=60;
    public static final int JavaIDDigit=61;
    public static final int ID=62;
    public static final int EXPONENT=63;
    public static final int COMMENT=64;
    public static final int WS=65;
    public static final int ESC_SEQ=66;
    public static final int HEX_DIGIT=67;
    public static final int UNICODE_ESC=68;
    public static final int OCTAL_ESC=69;

    // delegates
    // delegators


        public ExprGrammarParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public ExprGrammarParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return ExprGrammarParser.tokenNames; }
    public String getGrammarFileName() { return "ExprGrammar.g"; }


    public static class arg_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arg"
    // ExprGrammar.g:105:1: arg : value ;
    public final ExprGrammarParser.arg_return arg() throws RecognitionException {
        ExprGrammarParser.arg_return retval = new ExprGrammarParser.arg_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        ExprGrammarParser.value_return value1 = null;



        try {
            // ExprGrammar.g:106:5: ( value )
            // ExprGrammar.g:106:7: value
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_value_in_arg495);
            value1=value();

            state._fsp--;

            adaptor.addChild(root_0, value1.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "arg"

    public static class args_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "args"
    // ExprGrammar.g:109:1: args : arg ( COMMA arg )* ;
    public final ExprGrammarParser.args_return args() throws RecognitionException {
        ExprGrammarParser.args_return retval = new ExprGrammarParser.args_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA3=null;
        ExprGrammarParser.arg_return arg2 = null;

        ExprGrammarParser.arg_return arg4 = null;


        CommonTree COMMA3_tree=null;

        try {
            // ExprGrammar.g:110:5: ( arg ( COMMA arg )* )
            // ExprGrammar.g:110:7: arg ( COMMA arg )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_arg_in_args513);
            arg2=arg();

            state._fsp--;

            adaptor.addChild(root_0, arg2.getTree());
            // ExprGrammar.g:110:11: ( COMMA arg )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==COMMA) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ExprGrammar.g:110:12: COMMA arg
            	    {
            	    COMMA3=(Token)match(input,COMMA,FOLLOW_COMMA_in_args516); 
            	    pushFollow(FOLLOW_arg_in_args519);
            	    arg4=arg();

            	    state._fsp--;

            	    adaptor.addChild(root_0, arg4.getTree());

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "args"

    public static class value_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "value"
    // ExprGrammar.g:113:1: value : ( arithmeticExpression | geometry | list );
    public final ExprGrammarParser.value_return value() throws RecognitionException {
        ExprGrammarParser.value_return retval = new ExprGrammarParser.value_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression5 = null;

        ExprGrammarParser.geometry_return geometry6 = null;

        ExprGrammarParser.list_return list7 = null;



        try {
            // ExprGrammar.g:114:5: ( arithmeticExpression | geometry | list )
            int alt2=3;
            switch ( input.LA(1) ) {
            case LPAREN:
            case ADD:
            case SUB:
            case DATACOLUMNNAME:
            case TRUE:
            case FALSE:
            case INT:
            case FLOAT:
            case FUNCTION_CLASSIF_NO_CLASS_NUMBER:
            case FUNCTION_CLASSIF:
            case FUNCTION_CLASSIF_CUSTOM:
            case FUNCTION_N_TO_N:
            case FUNCTION_N1OR2_TO_N:
            case FUNCTION_G_TO_N:
            case FUNCTION_G_G_TO_N:
            case FUNCTION_S_TO_N:
            case FUNCTION_S_S_TO_N:
            case IF:
            case STRING:
            case FUNCTION_S_SPLUS_TO_S:
            case FUNCTION_N_SPLUS_TO_S:
            case FUNCTION_S_N1OR2_TO_S:
            case FUNCTION_S_TO_S:
            case NOT:
                {
                alt2=1;
                }
                break;
            case OMCOLUMNNAME:
            case FUNCTION_N_N_TO_G:
            case FUNCTION_G_TO_G:
            case FUNCTION_G_N_TO_G:
            case FUNCTION_G_N_N_TO_G:
            case FUNCTION_G_G_TO_G:
                {
                alt2=2;
                }
                break;
            case LBRACE:
                {
                alt2=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // ExprGrammar.g:114:7: arithmeticExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_arithmeticExpression_in_value538);
                    arithmeticExpression5=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression5.getTree());

                    }
                    break;
                case 2 :
                    // ExprGrammar.g:115:7: geometry
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_geometry_in_value546);
                    geometry6=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry6.getTree());

                    }
                    break;
                case 3 :
                    // ExprGrammar.g:116:7: list
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_list_in_value554);
                    list7=list();

                    state._fsp--;

                    adaptor.addChild(root_0, list7.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "value"

    public static class list_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "list"
    // ExprGrammar.g:118:1: list : LBRACE ( list_content )? RBRACE -> ^( LIST list_content ) ;
    public final ExprGrammarParser.list_return list() throws RecognitionException {
        ExprGrammarParser.list_return retval = new ExprGrammarParser.list_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LBRACE8=null;
        Token RBRACE10=null;
        ExprGrammarParser.list_content_return list_content9 = null;


        CommonTree LBRACE8_tree=null;
        CommonTree RBRACE10_tree=null;
        RewriteRuleTokenStream stream_RBRACE=new RewriteRuleTokenStream(adaptor,"token RBRACE");
        RewriteRuleTokenStream stream_LBRACE=new RewriteRuleTokenStream(adaptor,"token LBRACE");
        RewriteRuleSubtreeStream stream_list_content=new RewriteRuleSubtreeStream(adaptor,"rule list_content");
        try {
            // ExprGrammar.g:119:5: ( LBRACE ( list_content )? RBRACE -> ^( LIST list_content ) )
            // ExprGrammar.g:119:7: LBRACE ( list_content )? RBRACE
            {
            LBRACE8=(Token)match(input,LBRACE,FOLLOW_LBRACE_in_list571);  
            stream_LBRACE.add(LBRACE8);

            // ExprGrammar.g:119:14: ( list_content )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==LBRACE||LA3_0==LPAREN||(LA3_0>=ADD && LA3_0<=SUB)||(LA3_0>=DATACOLUMNNAME && LA3_0<=NOT)) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // ExprGrammar.g:119:14: list_content
                    {
                    pushFollow(FOLLOW_list_content_in_list573);
                    list_content9=list_content();

                    state._fsp--;

                    stream_list_content.add(list_content9.getTree());

                    }
                    break;

            }

            RBRACE10=(Token)match(input,RBRACE,FOLLOW_RBRACE_in_list576);  
            stream_RBRACE.add(RBRACE10);



            // AST REWRITE
            // elements: list_content
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 119:35: -> ^( LIST list_content )
            {
                // ExprGrammar.g:119:38: ^( LIST list_content )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(LIST, "LIST"), root_1);

                adaptor.addChild(root_1, stream_list_content.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "list"

    public static class list_content_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "list_content"
    // ExprGrammar.g:121:1: list_content : value ( COMMA value )* ;
    public final ExprGrammarParser.list_content_return list_content() throws RecognitionException {
        ExprGrammarParser.list_content_return retval = new ExprGrammarParser.list_content_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA12=null;
        ExprGrammarParser.value_return value11 = null;

        ExprGrammarParser.value_return value13 = null;


        CommonTree COMMA12_tree=null;

        try {
            // ExprGrammar.g:122:5: ( value ( COMMA value )* )
            // ExprGrammar.g:122:7: value ( COMMA value )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_value_in_list_content600);
            value11=value();

            state._fsp--;

            adaptor.addChild(root_0, value11.getTree());
            // ExprGrammar.g:122:13: ( COMMA value )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==COMMA) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // ExprGrammar.g:122:14: COMMA value
            	    {
            	    COMMA12=(Token)match(input,COMMA,FOLLOW_COMMA_in_list_content603); 
            	    pushFollow(FOLLOW_value_in_list_content606);
            	    value13=value();

            	    state._fsp--;

            	    adaptor.addChild(root_0, value13.getTree());

            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "list_content"

    public static class primaryExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "primaryExpression"
    // ExprGrammar.g:126:1: primaryExpression : ( TRUE | FALSE | DATACOLUMNNAME | INT | FLOAT | arithmeticFunctionCall | LPAREN arithmeticExpression RPAREN | stringExpr | classificationCall );
    public final ExprGrammarParser.primaryExpression_return primaryExpression() throws RecognitionException {
        ExprGrammarParser.primaryExpression_return retval = new ExprGrammarParser.primaryExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token TRUE14=null;
        Token FALSE15=null;
        Token DATACOLUMNNAME16=null;
        Token INT17=null;
        Token FLOAT18=null;
        Token LPAREN20=null;
        Token RPAREN22=null;
        ExprGrammarParser.arithmeticFunctionCall_return arithmeticFunctionCall19 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression21 = null;

        ExprGrammarParser.stringExpr_return stringExpr23 = null;

        ExprGrammarParser.classificationCall_return classificationCall24 = null;


        CommonTree TRUE14_tree=null;
        CommonTree FALSE15_tree=null;
        CommonTree DATACOLUMNNAME16_tree=null;
        CommonTree INT17_tree=null;
        CommonTree FLOAT18_tree=null;
        CommonTree LPAREN20_tree=null;
        CommonTree RPAREN22_tree=null;

        try {
            // ExprGrammar.g:127:5: ( TRUE | FALSE | DATACOLUMNNAME | INT | FLOAT | arithmeticFunctionCall | LPAREN arithmeticExpression RPAREN | stringExpr | classificationCall )
            int alt5=9;
            switch ( input.LA(1) ) {
            case TRUE:
                {
                alt5=1;
                }
                break;
            case FALSE:
                {
                alt5=2;
                }
                break;
            case DATACOLUMNNAME:
                {
                alt5=3;
                }
                break;
            case INT:
                {
                alt5=4;
                }
                break;
            case FLOAT:
                {
                alt5=5;
                }
                break;
            case FUNCTION_N_TO_N:
            case FUNCTION_N1OR2_TO_N:
            case FUNCTION_G_TO_N:
            case FUNCTION_G_G_TO_N:
            case FUNCTION_S_TO_N:
            case FUNCTION_S_S_TO_N:
            case IF:
                {
                alt5=6;
                }
                break;
            case LPAREN:
                {
                alt5=7;
                }
                break;
            case STRING:
            case FUNCTION_S_SPLUS_TO_S:
            case FUNCTION_N_SPLUS_TO_S:
            case FUNCTION_S_N1OR2_TO_S:
            case FUNCTION_S_TO_S:
                {
                alt5=8;
                }
                break;
            case FUNCTION_CLASSIF_NO_CLASS_NUMBER:
            case FUNCTION_CLASSIF:
            case FUNCTION_CLASSIF_CUSTOM:
                {
                alt5=9;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // ExprGrammar.g:127:7: TRUE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    TRUE14=(Token)match(input,TRUE,FOLLOW_TRUE_in_primaryExpression627); 
                    TRUE14_tree = (CommonTree)adaptor.create(TRUE14);
                    adaptor.addChild(root_0, TRUE14_tree);


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:128:7: FALSE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FALSE15=(Token)match(input,FALSE,FOLLOW_FALSE_in_primaryExpression635); 
                    FALSE15_tree = (CommonTree)adaptor.create(FALSE15);
                    adaptor.addChild(root_0, FALSE15_tree);


                    }
                    break;
                case 3 :
                    // ExprGrammar.g:129:7: DATACOLUMNNAME
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    DATACOLUMNNAME16=(Token)match(input,DATACOLUMNNAME,FOLLOW_DATACOLUMNNAME_in_primaryExpression643); 
                    DATACOLUMNNAME16_tree = (CommonTree)adaptor.create(DATACOLUMNNAME16);
                    adaptor.addChild(root_0, DATACOLUMNNAME16_tree);


                    }
                    break;
                case 4 :
                    // ExprGrammar.g:130:7: INT
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    INT17=(Token)match(input,INT,FOLLOW_INT_in_primaryExpression651); 
                    INT17_tree = (CommonTree)adaptor.create(INT17);
                    adaptor.addChild(root_0, INT17_tree);


                    }
                    break;
                case 5 :
                    // ExprGrammar.g:130:13: FLOAT
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FLOAT18=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_primaryExpression655); 
                    FLOAT18_tree = (CommonTree)adaptor.create(FLOAT18);
                    adaptor.addChild(root_0, FLOAT18_tree);


                    }
                    break;
                case 6 :
                    // ExprGrammar.g:131:7: arithmeticFunctionCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_arithmeticFunctionCall_in_primaryExpression663);
                    arithmeticFunctionCall19=arithmeticFunctionCall();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticFunctionCall19.getTree());

                    }
                    break;
                case 7 :
                    // ExprGrammar.g:132:7: LPAREN arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    LPAREN20=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_primaryExpression671); 
                    pushFollow(FOLLOW_arithmeticExpression_in_primaryExpression674);
                    arithmeticExpression21=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression21.getTree());
                    RPAREN22=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_primaryExpression676); 

                    }
                    break;
                case 8 :
                    // ExprGrammar.g:133:7: stringExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_stringExpr_in_primaryExpression685);
                    stringExpr23=stringExpr();

                    state._fsp--;

                    adaptor.addChild(root_0, stringExpr23.getTree());

                    }
                    break;
                case 9 :
                    // ExprGrammar.g:134:7: classificationCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_classificationCall_in_primaryExpression693);
                    classificationCall24=classificationCall();

                    state._fsp--;

                    adaptor.addChild(root_0, classificationCall24.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "primaryExpression"

    public static class classificationCall_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "classificationCall"
    // ExprGrammar.g:137:1: classificationCall : ( FUNCTION_CLASSIF_NO_CLASS_NUMBER LPAREN DATACOLUMNNAME ( COMMA arithmeticExpression )? RPAREN | FUNCTION_CLASSIF LPAREN DATACOLUMNNAME COMMA INT ( COMMA arithmeticExpression )? RPAREN | FUNCTION_CLASSIF_CUSTOM LPAREN DATACOLUMNNAME ( COMMA arithmeticExpression )+ RPAREN );
    public final ExprGrammarParser.classificationCall_return classificationCall() throws RecognitionException {
        ExprGrammarParser.classificationCall_return retval = new ExprGrammarParser.classificationCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token FUNCTION_CLASSIF_NO_CLASS_NUMBER25=null;
        Token LPAREN26=null;
        Token DATACOLUMNNAME27=null;
        Token COMMA28=null;
        Token RPAREN30=null;
        Token FUNCTION_CLASSIF31=null;
        Token LPAREN32=null;
        Token DATACOLUMNNAME33=null;
        Token COMMA34=null;
        Token INT35=null;
        Token COMMA36=null;
        Token RPAREN38=null;
        Token FUNCTION_CLASSIF_CUSTOM39=null;
        Token LPAREN40=null;
        Token DATACOLUMNNAME41=null;
        Token COMMA42=null;
        Token RPAREN44=null;
        ExprGrammarParser.arithmeticExpression_return arithmeticExpression29 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression37 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression43 = null;


        CommonTree FUNCTION_CLASSIF_NO_CLASS_NUMBER25_tree=null;
        CommonTree LPAREN26_tree=null;
        CommonTree DATACOLUMNNAME27_tree=null;
        CommonTree COMMA28_tree=null;
        CommonTree RPAREN30_tree=null;
        CommonTree FUNCTION_CLASSIF31_tree=null;
        CommonTree LPAREN32_tree=null;
        CommonTree DATACOLUMNNAME33_tree=null;
        CommonTree COMMA34_tree=null;
        CommonTree INT35_tree=null;
        CommonTree COMMA36_tree=null;
        CommonTree RPAREN38_tree=null;
        CommonTree FUNCTION_CLASSIF_CUSTOM39_tree=null;
        CommonTree LPAREN40_tree=null;
        CommonTree DATACOLUMNNAME41_tree=null;
        CommonTree COMMA42_tree=null;
        CommonTree RPAREN44_tree=null;

        try {
            // ExprGrammar.g:138:5: ( FUNCTION_CLASSIF_NO_CLASS_NUMBER LPAREN DATACOLUMNNAME ( COMMA arithmeticExpression )? RPAREN | FUNCTION_CLASSIF LPAREN DATACOLUMNNAME COMMA INT ( COMMA arithmeticExpression )? RPAREN | FUNCTION_CLASSIF_CUSTOM LPAREN DATACOLUMNNAME ( COMMA arithmeticExpression )+ RPAREN )
            int alt9=3;
            switch ( input.LA(1) ) {
            case FUNCTION_CLASSIF_NO_CLASS_NUMBER:
                {
                alt9=1;
                }
                break;
            case FUNCTION_CLASSIF:
                {
                alt9=2;
                }
                break;
            case FUNCTION_CLASSIF_CUSTOM:
                {
                alt9=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // ExprGrammar.g:138:7: FUNCTION_CLASSIF_NO_CLASS_NUMBER LPAREN DATACOLUMNNAME ( COMMA arithmeticExpression )? RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_CLASSIF_NO_CLASS_NUMBER25=(Token)match(input,FUNCTION_CLASSIF_NO_CLASS_NUMBER,FOLLOW_FUNCTION_CLASSIF_NO_CLASS_NUMBER_in_classificationCall711); 
                    FUNCTION_CLASSIF_NO_CLASS_NUMBER25_tree = (CommonTree)adaptor.create(FUNCTION_CLASSIF_NO_CLASS_NUMBER25);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_CLASSIF_NO_CLASS_NUMBER25_tree, root_0);

                    LPAREN26=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_classificationCall715); 
                    DATACOLUMNNAME27=(Token)match(input,DATACOLUMNNAME,FOLLOW_DATACOLUMNNAME_in_classificationCall718); 
                    DATACOLUMNNAME27_tree = (CommonTree)adaptor.create(DATACOLUMNNAME27);
                    adaptor.addChild(root_0, DATACOLUMNNAME27_tree);

                    // ExprGrammar.g:138:65: ( COMMA arithmeticExpression )?
                    int alt6=2;
                    int LA6_0 = input.LA(1);

                    if ( (LA6_0==COMMA) ) {
                        alt6=1;
                    }
                    switch (alt6) {
                        case 1 :
                            // ExprGrammar.g:138:66: COMMA arithmeticExpression
                            {
                            COMMA28=(Token)match(input,COMMA,FOLLOW_COMMA_in_classificationCall721); 
                            pushFollow(FOLLOW_arithmeticExpression_in_classificationCall724);
                            arithmeticExpression29=arithmeticExpression();

                            state._fsp--;

                            adaptor.addChild(root_0, arithmeticExpression29.getTree());

                            }
                            break;

                    }

                    RPAREN30=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_classificationCall728); 

                    }
                    break;
                case 2 :
                    // ExprGrammar.g:139:7: FUNCTION_CLASSIF LPAREN DATACOLUMNNAME COMMA INT ( COMMA arithmeticExpression )? RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_CLASSIF31=(Token)match(input,FUNCTION_CLASSIF,FOLLOW_FUNCTION_CLASSIF_in_classificationCall738); 
                    FUNCTION_CLASSIF31_tree = (CommonTree)adaptor.create(FUNCTION_CLASSIF31);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_CLASSIF31_tree, root_0);

                    LPAREN32=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_classificationCall742); 
                    DATACOLUMNNAME33=(Token)match(input,DATACOLUMNNAME,FOLLOW_DATACOLUMNNAME_in_classificationCall745); 
                    DATACOLUMNNAME33_tree = (CommonTree)adaptor.create(DATACOLUMNNAME33);
                    adaptor.addChild(root_0, DATACOLUMNNAME33_tree);

                    COMMA34=(Token)match(input,COMMA,FOLLOW_COMMA_in_classificationCall747); 
                    INT35=(Token)match(input,INT,FOLLOW_INT_in_classificationCall750); 
                    INT35_tree = (CommonTree)adaptor.create(INT35);
                    adaptor.addChild(root_0, INT35_tree);

                    // ExprGrammar.g:139:61: ( COMMA arithmeticExpression )?
                    int alt7=2;
                    int LA7_0 = input.LA(1);

                    if ( (LA7_0==COMMA) ) {
                        alt7=1;
                    }
                    switch (alt7) {
                        case 1 :
                            // ExprGrammar.g:139:62: COMMA arithmeticExpression
                            {
                            COMMA36=(Token)match(input,COMMA,FOLLOW_COMMA_in_classificationCall754); 
                            pushFollow(FOLLOW_arithmeticExpression_in_classificationCall757);
                            arithmeticExpression37=arithmeticExpression();

                            state._fsp--;

                            adaptor.addChild(root_0, arithmeticExpression37.getTree());

                            }
                            break;

                    }

                    RPAREN38=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_classificationCall761); 

                    }
                    break;
                case 3 :
                    // ExprGrammar.g:140:7: FUNCTION_CLASSIF_CUSTOM LPAREN DATACOLUMNNAME ( COMMA arithmeticExpression )+ RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_CLASSIF_CUSTOM39=(Token)match(input,FUNCTION_CLASSIF_CUSTOM,FOLLOW_FUNCTION_CLASSIF_CUSTOM_in_classificationCall771); 
                    FUNCTION_CLASSIF_CUSTOM39_tree = (CommonTree)adaptor.create(FUNCTION_CLASSIF_CUSTOM39);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_CLASSIF_CUSTOM39_tree, root_0);

                    LPAREN40=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_classificationCall775); 
                    DATACOLUMNNAME41=(Token)match(input,DATACOLUMNNAME,FOLLOW_DATACOLUMNNAME_in_classificationCall778); 
                    DATACOLUMNNAME41_tree = (CommonTree)adaptor.create(DATACOLUMNNAME41);
                    adaptor.addChild(root_0, DATACOLUMNNAME41_tree);

                    // ExprGrammar.g:140:56: ( COMMA arithmeticExpression )+
                    int cnt8=0;
                    loop8:
                    do {
                        int alt8=2;
                        int LA8_0 = input.LA(1);

                        if ( (LA8_0==COMMA) ) {
                            alt8=1;
                        }


                        switch (alt8) {
                    	case 1 :
                    	    // ExprGrammar.g:140:57: COMMA arithmeticExpression
                    	    {
                    	    COMMA42=(Token)match(input,COMMA,FOLLOW_COMMA_in_classificationCall781); 
                    	    pushFollow(FOLLOW_arithmeticExpression_in_classificationCall784);
                    	    arithmeticExpression43=arithmeticExpression();

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, arithmeticExpression43.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt8 >= 1 ) break loop8;
                                EarlyExitException eee =
                                    new EarlyExitException(8, input);
                                throw eee;
                        }
                        cnt8++;
                    } while (true);

                    RPAREN44=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_classificationCall788); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "classificationCall"

    public static class arithmeticFunctionCall_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arithmeticFunctionCall"
    // ExprGrammar.g:142:1: arithmeticFunctionCall : ( FUNCTION_N_TO_N LPAREN arithmeticExpression RPAREN | FUNCTION_N1OR2_TO_N LPAREN arithmeticExpression ( COMMA arithmeticExpression )? RPAREN | FUNCTION_G_TO_N LPAREN geometry RPAREN | FUNCTION_G_G_TO_N LPAREN geometry COMMA geometry RPAREN | FUNCTION_S_TO_N LPAREN arithmeticExpression RPAREN | FUNCTION_S_S_TO_N LPAREN arithmeticExpression COMMA arithmeticExpression RPAREN | IF LPAREN logicalORExpression COMMA arithmeticExpression COMMA arithmeticExpression RPAREN );
    public final ExprGrammarParser.arithmeticFunctionCall_return arithmeticFunctionCall() throws RecognitionException {
        ExprGrammarParser.arithmeticFunctionCall_return retval = new ExprGrammarParser.arithmeticFunctionCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token FUNCTION_N_TO_N45=null;
        Token LPAREN46=null;
        Token RPAREN48=null;
        Token FUNCTION_N1OR2_TO_N49=null;
        Token LPAREN50=null;
        Token COMMA52=null;
        Token RPAREN54=null;
        Token FUNCTION_G_TO_N55=null;
        Token LPAREN56=null;
        Token RPAREN58=null;
        Token FUNCTION_G_G_TO_N59=null;
        Token LPAREN60=null;
        Token COMMA62=null;
        Token RPAREN64=null;
        Token FUNCTION_S_TO_N65=null;
        Token LPAREN66=null;
        Token RPAREN68=null;
        Token FUNCTION_S_S_TO_N69=null;
        Token LPAREN70=null;
        Token COMMA72=null;
        Token RPAREN74=null;
        Token IF75=null;
        Token LPAREN76=null;
        Token COMMA78=null;
        Token COMMA80=null;
        Token RPAREN82=null;
        ExprGrammarParser.arithmeticExpression_return arithmeticExpression47 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression51 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression53 = null;

        ExprGrammarParser.geometry_return geometry57 = null;

        ExprGrammarParser.geometry_return geometry61 = null;

        ExprGrammarParser.geometry_return geometry63 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression67 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression71 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression73 = null;

        ExprGrammarParser.logicalORExpression_return logicalORExpression77 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression79 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression81 = null;


        CommonTree FUNCTION_N_TO_N45_tree=null;
        CommonTree LPAREN46_tree=null;
        CommonTree RPAREN48_tree=null;
        CommonTree FUNCTION_N1OR2_TO_N49_tree=null;
        CommonTree LPAREN50_tree=null;
        CommonTree COMMA52_tree=null;
        CommonTree RPAREN54_tree=null;
        CommonTree FUNCTION_G_TO_N55_tree=null;
        CommonTree LPAREN56_tree=null;
        CommonTree RPAREN58_tree=null;
        CommonTree FUNCTION_G_G_TO_N59_tree=null;
        CommonTree LPAREN60_tree=null;
        CommonTree COMMA62_tree=null;
        CommonTree RPAREN64_tree=null;
        CommonTree FUNCTION_S_TO_N65_tree=null;
        CommonTree LPAREN66_tree=null;
        CommonTree RPAREN68_tree=null;
        CommonTree FUNCTION_S_S_TO_N69_tree=null;
        CommonTree LPAREN70_tree=null;
        CommonTree COMMA72_tree=null;
        CommonTree RPAREN74_tree=null;
        CommonTree IF75_tree=null;
        CommonTree LPAREN76_tree=null;
        CommonTree COMMA78_tree=null;
        CommonTree COMMA80_tree=null;
        CommonTree RPAREN82_tree=null;

        try {
            // ExprGrammar.g:143:5: ( FUNCTION_N_TO_N LPAREN arithmeticExpression RPAREN | FUNCTION_N1OR2_TO_N LPAREN arithmeticExpression ( COMMA arithmeticExpression )? RPAREN | FUNCTION_G_TO_N LPAREN geometry RPAREN | FUNCTION_G_G_TO_N LPAREN geometry COMMA geometry RPAREN | FUNCTION_S_TO_N LPAREN arithmeticExpression RPAREN | FUNCTION_S_S_TO_N LPAREN arithmeticExpression COMMA arithmeticExpression RPAREN | IF LPAREN logicalORExpression COMMA arithmeticExpression COMMA arithmeticExpression RPAREN )
            int alt11=7;
            switch ( input.LA(1) ) {
            case FUNCTION_N_TO_N:
                {
                alt11=1;
                }
                break;
            case FUNCTION_N1OR2_TO_N:
                {
                alt11=2;
                }
                break;
            case FUNCTION_G_TO_N:
                {
                alt11=3;
                }
                break;
            case FUNCTION_G_G_TO_N:
                {
                alt11=4;
                }
                break;
            case FUNCTION_S_TO_N:
                {
                alt11=5;
                }
                break;
            case FUNCTION_S_S_TO_N:
                {
                alt11=6;
                }
                break;
            case IF:
                {
                alt11=7;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 11, 0, input);

                throw nvae;
            }

            switch (alt11) {
                case 1 :
                    // ExprGrammar.g:143:7: FUNCTION_N_TO_N LPAREN arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_N_TO_N45=(Token)match(input,FUNCTION_N_TO_N,FOLLOW_FUNCTION_N_TO_N_in_arithmeticFunctionCall806); 
                    FUNCTION_N_TO_N45_tree = (CommonTree)adaptor.create(FUNCTION_N_TO_N45);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_N_TO_N45_tree, root_0);

                    LPAREN46=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_arithmeticFunctionCall809); 
                    pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall812);
                    arithmeticExpression47=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression47.getTree());
                    RPAREN48=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_arithmeticFunctionCall814); 

                    }
                    break;
                case 2 :
                    // ExprGrammar.g:144:7: FUNCTION_N1OR2_TO_N LPAREN arithmeticExpression ( COMMA arithmeticExpression )? RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_N1OR2_TO_N49=(Token)match(input,FUNCTION_N1OR2_TO_N,FOLLOW_FUNCTION_N1OR2_TO_N_in_arithmeticFunctionCall824); 
                    FUNCTION_N1OR2_TO_N49_tree = (CommonTree)adaptor.create(FUNCTION_N1OR2_TO_N49);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_N1OR2_TO_N49_tree, root_0);

                    LPAREN50=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_arithmeticFunctionCall827); 
                    pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall830);
                    arithmeticExpression51=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression51.getTree());
                    // ExprGrammar.g:144:57: ( COMMA arithmeticExpression )?
                    int alt10=2;
                    int LA10_0 = input.LA(1);

                    if ( (LA10_0==COMMA) ) {
                        alt10=1;
                    }
                    switch (alt10) {
                        case 1 :
                            // ExprGrammar.g:144:58: COMMA arithmeticExpression
                            {
                            COMMA52=(Token)match(input,COMMA,FOLLOW_COMMA_in_arithmeticFunctionCall833); 
                            pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall836);
                            arithmeticExpression53=arithmeticExpression();

                            state._fsp--;

                            adaptor.addChild(root_0, arithmeticExpression53.getTree());

                            }
                            break;

                    }

                    RPAREN54=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_arithmeticFunctionCall840); 

                    }
                    break;
                case 3 :
                    // ExprGrammar.g:145:7: FUNCTION_G_TO_N LPAREN geometry RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_G_TO_N55=(Token)match(input,FUNCTION_G_TO_N,FOLLOW_FUNCTION_G_TO_N_in_arithmeticFunctionCall850); 
                    FUNCTION_G_TO_N55_tree = (CommonTree)adaptor.create(FUNCTION_G_TO_N55);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_G_TO_N55_tree, root_0);

                    LPAREN56=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_arithmeticFunctionCall853); 
                    pushFollow(FOLLOW_geometry_in_arithmeticFunctionCall856);
                    geometry57=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry57.getTree());
                    RPAREN58=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_arithmeticFunctionCall858); 

                    }
                    break;
                case 4 :
                    // ExprGrammar.g:146:7: FUNCTION_G_G_TO_N LPAREN geometry COMMA geometry RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_G_G_TO_N59=(Token)match(input,FUNCTION_G_G_TO_N,FOLLOW_FUNCTION_G_G_TO_N_in_arithmeticFunctionCall867); 
                    FUNCTION_G_G_TO_N59_tree = (CommonTree)adaptor.create(FUNCTION_G_G_TO_N59);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_G_G_TO_N59_tree, root_0);

                    LPAREN60=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_arithmeticFunctionCall870); 
                    pushFollow(FOLLOW_geometry_in_arithmeticFunctionCall873);
                    geometry61=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry61.getTree());
                    COMMA62=(Token)match(input,COMMA,FOLLOW_COMMA_in_arithmeticFunctionCall875); 
                    pushFollow(FOLLOW_geometry_in_arithmeticFunctionCall878);
                    geometry63=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry63.getTree());
                    RPAREN64=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_arithmeticFunctionCall880); 

                    }
                    break;
                case 5 :
                    // ExprGrammar.g:147:7: FUNCTION_S_TO_N LPAREN arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_S_TO_N65=(Token)match(input,FUNCTION_S_TO_N,FOLLOW_FUNCTION_S_TO_N_in_arithmeticFunctionCall889); 
                    FUNCTION_S_TO_N65_tree = (CommonTree)adaptor.create(FUNCTION_S_TO_N65);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_S_TO_N65_tree, root_0);

                    LPAREN66=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_arithmeticFunctionCall892); 
                    pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall895);
                    arithmeticExpression67=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression67.getTree());
                    RPAREN68=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_arithmeticFunctionCall897); 

                    }
                    break;
                case 6 :
                    // ExprGrammar.g:148:7: FUNCTION_S_S_TO_N LPAREN arithmeticExpression COMMA arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_S_S_TO_N69=(Token)match(input,FUNCTION_S_S_TO_N,FOLLOW_FUNCTION_S_S_TO_N_in_arithmeticFunctionCall907); 
                    FUNCTION_S_S_TO_N69_tree = (CommonTree)adaptor.create(FUNCTION_S_S_TO_N69);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_S_S_TO_N69_tree, root_0);

                    LPAREN70=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_arithmeticFunctionCall910); 
                    pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall913);
                    arithmeticExpression71=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression71.getTree());
                    COMMA72=(Token)match(input,COMMA,FOLLOW_COMMA_in_arithmeticFunctionCall915); 
                    pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall918);
                    arithmeticExpression73=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression73.getTree());
                    RPAREN74=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_arithmeticFunctionCall920); 

                    }
                    break;
                case 7 :
                    // ExprGrammar.g:149:7: IF LPAREN logicalORExpression COMMA arithmeticExpression COMMA arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    IF75=(Token)match(input,IF,FOLLOW_IF_in_arithmeticFunctionCall930); 
                    IF75_tree = (CommonTree)adaptor.create(IF75);
                    root_0 = (CommonTree)adaptor.becomeRoot(IF75_tree, root_0);

                    LPAREN76=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_arithmeticFunctionCall933); 
                    pushFollow(FOLLOW_logicalORExpression_in_arithmeticFunctionCall936);
                    logicalORExpression77=logicalORExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, logicalORExpression77.getTree());
                    COMMA78=(Token)match(input,COMMA,FOLLOW_COMMA_in_arithmeticFunctionCall938); 
                    pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall941);
                    arithmeticExpression79=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression79.getTree());
                    COMMA80=(Token)match(input,COMMA,FOLLOW_COMMA_in_arithmeticFunctionCall943); 
                    pushFollow(FOLLOW_arithmeticExpression_in_arithmeticFunctionCall946);
                    arithmeticExpression81=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression81.getTree());
                    RPAREN82=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_arithmeticFunctionCall948); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "arithmeticFunctionCall"

    public static class geometry_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "geometry"
    // ExprGrammar.g:152:1: geometry : ( OMCOLUMNNAME | geometryFunctionCall );
    public final ExprGrammarParser.geometry_return geometry() throws RecognitionException {
        ExprGrammarParser.geometry_return retval = new ExprGrammarParser.geometry_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OMCOLUMNNAME83=null;
        ExprGrammarParser.geometryFunctionCall_return geometryFunctionCall84 = null;


        CommonTree OMCOLUMNNAME83_tree=null;

        try {
            // ExprGrammar.g:153:5: ( OMCOLUMNNAME | geometryFunctionCall )
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==OMCOLUMNNAME) ) {
                alt12=1;
            }
            else if ( ((LA12_0>=FUNCTION_N_N_TO_G && LA12_0<=FUNCTION_G_G_TO_G)) ) {
                alt12=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 12, 0, input);

                throw nvae;
            }
            switch (alt12) {
                case 1 :
                    // ExprGrammar.g:153:7: OMCOLUMNNAME
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    OMCOLUMNNAME83=(Token)match(input,OMCOLUMNNAME,FOLLOW_OMCOLUMNNAME_in_geometry971); 
                    OMCOLUMNNAME83_tree = (CommonTree)adaptor.create(OMCOLUMNNAME83);
                    adaptor.addChild(root_0, OMCOLUMNNAME83_tree);


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:154:7: geometryFunctionCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_geometryFunctionCall_in_geometry979);
                    geometryFunctionCall84=geometryFunctionCall();

                    state._fsp--;

                    adaptor.addChild(root_0, geometryFunctionCall84.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "geometry"

    public static class geometryFunctionCall_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "geometryFunctionCall"
    // ExprGrammar.g:157:1: geometryFunctionCall : ( FUNCTION_N_N_TO_G LPAREN arithmeticExpression COMMA arithmeticExpression RPAREN | FUNCTION_G_TO_G LPAREN geometry RPAREN | FUNCTION_G_N_TO_G LPAREN geometry COMMA arithmeticExpression RPAREN | FUNCTION_G_N_N_TO_G LPAREN geometry COMMA arithmeticExpression COMMA arithmeticExpression RPAREN | FUNCTION_G_G_TO_G LPAREN geometry COMMA geometry RPAREN );
    public final ExprGrammarParser.geometryFunctionCall_return geometryFunctionCall() throws RecognitionException {
        ExprGrammarParser.geometryFunctionCall_return retval = new ExprGrammarParser.geometryFunctionCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token FUNCTION_N_N_TO_G85=null;
        Token LPAREN86=null;
        Token COMMA88=null;
        Token RPAREN90=null;
        Token FUNCTION_G_TO_G91=null;
        Token LPAREN92=null;
        Token RPAREN94=null;
        Token FUNCTION_G_N_TO_G95=null;
        Token LPAREN96=null;
        Token COMMA98=null;
        Token RPAREN100=null;
        Token FUNCTION_G_N_N_TO_G101=null;
        Token LPAREN102=null;
        Token COMMA104=null;
        Token COMMA106=null;
        Token RPAREN108=null;
        Token FUNCTION_G_G_TO_G109=null;
        Token LPAREN110=null;
        Token COMMA112=null;
        Token RPAREN114=null;
        ExprGrammarParser.arithmeticExpression_return arithmeticExpression87 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression89 = null;

        ExprGrammarParser.geometry_return geometry93 = null;

        ExprGrammarParser.geometry_return geometry97 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression99 = null;

        ExprGrammarParser.geometry_return geometry103 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression105 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression107 = null;

        ExprGrammarParser.geometry_return geometry111 = null;

        ExprGrammarParser.geometry_return geometry113 = null;


        CommonTree FUNCTION_N_N_TO_G85_tree=null;
        CommonTree LPAREN86_tree=null;
        CommonTree COMMA88_tree=null;
        CommonTree RPAREN90_tree=null;
        CommonTree FUNCTION_G_TO_G91_tree=null;
        CommonTree LPAREN92_tree=null;
        CommonTree RPAREN94_tree=null;
        CommonTree FUNCTION_G_N_TO_G95_tree=null;
        CommonTree LPAREN96_tree=null;
        CommonTree COMMA98_tree=null;
        CommonTree RPAREN100_tree=null;
        CommonTree FUNCTION_G_N_N_TO_G101_tree=null;
        CommonTree LPAREN102_tree=null;
        CommonTree COMMA104_tree=null;
        CommonTree COMMA106_tree=null;
        CommonTree RPAREN108_tree=null;
        CommonTree FUNCTION_G_G_TO_G109_tree=null;
        CommonTree LPAREN110_tree=null;
        CommonTree COMMA112_tree=null;
        CommonTree RPAREN114_tree=null;

        try {
            // ExprGrammar.g:158:5: ( FUNCTION_N_N_TO_G LPAREN arithmeticExpression COMMA arithmeticExpression RPAREN | FUNCTION_G_TO_G LPAREN geometry RPAREN | FUNCTION_G_N_TO_G LPAREN geometry COMMA arithmeticExpression RPAREN | FUNCTION_G_N_N_TO_G LPAREN geometry COMMA arithmeticExpression COMMA arithmeticExpression RPAREN | FUNCTION_G_G_TO_G LPAREN geometry COMMA geometry RPAREN )
            int alt13=5;
            switch ( input.LA(1) ) {
            case FUNCTION_N_N_TO_G:
                {
                alt13=1;
                }
                break;
            case FUNCTION_G_TO_G:
                {
                alt13=2;
                }
                break;
            case FUNCTION_G_N_TO_G:
                {
                alt13=3;
                }
                break;
            case FUNCTION_G_N_N_TO_G:
                {
                alt13=4;
                }
                break;
            case FUNCTION_G_G_TO_G:
                {
                alt13=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 13, 0, input);

                throw nvae;
            }

            switch (alt13) {
                case 1 :
                    // ExprGrammar.g:158:7: FUNCTION_N_N_TO_G LPAREN arithmeticExpression COMMA arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_N_N_TO_G85=(Token)match(input,FUNCTION_N_N_TO_G,FOLLOW_FUNCTION_N_N_TO_G_in_geometryFunctionCall996); 
                    FUNCTION_N_N_TO_G85_tree = (CommonTree)adaptor.create(FUNCTION_N_N_TO_G85);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_N_N_TO_G85_tree, root_0);

                    LPAREN86=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_geometryFunctionCall999); 
                    pushFollow(FOLLOW_arithmeticExpression_in_geometryFunctionCall1002);
                    arithmeticExpression87=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression87.getTree());
                    COMMA88=(Token)match(input,COMMA,FOLLOW_COMMA_in_geometryFunctionCall1004); 
                    pushFollow(FOLLOW_arithmeticExpression_in_geometryFunctionCall1007);
                    arithmeticExpression89=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression89.getTree());
                    RPAREN90=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_geometryFunctionCall1009); 

                    }
                    break;
                case 2 :
                    // ExprGrammar.g:159:7: FUNCTION_G_TO_G LPAREN geometry RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_G_TO_G91=(Token)match(input,FUNCTION_G_TO_G,FOLLOW_FUNCTION_G_TO_G_in_geometryFunctionCall1019); 
                    FUNCTION_G_TO_G91_tree = (CommonTree)adaptor.create(FUNCTION_G_TO_G91);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_G_TO_G91_tree, root_0);

                    LPAREN92=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_geometryFunctionCall1022); 
                    pushFollow(FOLLOW_geometry_in_geometryFunctionCall1025);
                    geometry93=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry93.getTree());
                    RPAREN94=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_geometryFunctionCall1027); 

                    }
                    break;
                case 3 :
                    // ExprGrammar.g:160:7: FUNCTION_G_N_TO_G LPAREN geometry COMMA arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_G_N_TO_G95=(Token)match(input,FUNCTION_G_N_TO_G,FOLLOW_FUNCTION_G_N_TO_G_in_geometryFunctionCall1037); 
                    FUNCTION_G_N_TO_G95_tree = (CommonTree)adaptor.create(FUNCTION_G_N_TO_G95);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_G_N_TO_G95_tree, root_0);

                    LPAREN96=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_geometryFunctionCall1040); 
                    pushFollow(FOLLOW_geometry_in_geometryFunctionCall1043);
                    geometry97=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry97.getTree());
                    COMMA98=(Token)match(input,COMMA,FOLLOW_COMMA_in_geometryFunctionCall1045); 
                    pushFollow(FOLLOW_arithmeticExpression_in_geometryFunctionCall1048);
                    arithmeticExpression99=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression99.getTree());
                    RPAREN100=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_geometryFunctionCall1050); 

                    }
                    break;
                case 4 :
                    // ExprGrammar.g:161:7: FUNCTION_G_N_N_TO_G LPAREN geometry COMMA arithmeticExpression COMMA arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_G_N_N_TO_G101=(Token)match(input,FUNCTION_G_N_N_TO_G,FOLLOW_FUNCTION_G_N_N_TO_G_in_geometryFunctionCall1060); 
                    FUNCTION_G_N_N_TO_G101_tree = (CommonTree)adaptor.create(FUNCTION_G_N_N_TO_G101);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_G_N_N_TO_G101_tree, root_0);

                    LPAREN102=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_geometryFunctionCall1063); 
                    pushFollow(FOLLOW_geometry_in_geometryFunctionCall1066);
                    geometry103=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry103.getTree());
                    COMMA104=(Token)match(input,COMMA,FOLLOW_COMMA_in_geometryFunctionCall1068); 
                    pushFollow(FOLLOW_arithmeticExpression_in_geometryFunctionCall1071);
                    arithmeticExpression105=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression105.getTree());
                    COMMA106=(Token)match(input,COMMA,FOLLOW_COMMA_in_geometryFunctionCall1073); 
                    pushFollow(FOLLOW_arithmeticExpression_in_geometryFunctionCall1076);
                    arithmeticExpression107=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression107.getTree());
                    RPAREN108=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_geometryFunctionCall1078); 

                    }
                    break;
                case 5 :
                    // ExprGrammar.g:162:7: FUNCTION_G_G_TO_G LPAREN geometry COMMA geometry RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_G_G_TO_G109=(Token)match(input,FUNCTION_G_G_TO_G,FOLLOW_FUNCTION_G_G_TO_G_in_geometryFunctionCall1088); 
                    FUNCTION_G_G_TO_G109_tree = (CommonTree)adaptor.create(FUNCTION_G_G_TO_G109);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_G_G_TO_G109_tree, root_0);

                    LPAREN110=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_geometryFunctionCall1091); 
                    pushFollow(FOLLOW_geometry_in_geometryFunctionCall1094);
                    geometry111=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry111.getTree());
                    COMMA112=(Token)match(input,COMMA,FOLLOW_COMMA_in_geometryFunctionCall1096); 
                    pushFollow(FOLLOW_geometry_in_geometryFunctionCall1099);
                    geometry113=geometry();

                    state._fsp--;

                    adaptor.addChild(root_0, geometry113.getTree());
                    RPAREN114=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_geometryFunctionCall1101); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "geometryFunctionCall"

    public static class stringExpr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "stringExpr"
    // ExprGrammar.g:165:1: stringExpr : ( STRING | FUNCTION_S_SPLUS_TO_S LPAREN arithmeticExpression ( COMMA arithmeticExpression )+ RPAREN | FUNCTION_N_SPLUS_TO_S LPAREN arithmeticExpression ( COMMA arithmeticExpression )+ RPAREN | FUNCTION_S_N1OR2_TO_S LPAREN arithmeticExpression COMMA arithmeticExpression ( COMMA arithmeticExpression )? RPAREN | FUNCTION_S_TO_S LPAREN arithmeticExpression RPAREN );
    public final ExprGrammarParser.stringExpr_return stringExpr() throws RecognitionException {
        ExprGrammarParser.stringExpr_return retval = new ExprGrammarParser.stringExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STRING115=null;
        Token FUNCTION_S_SPLUS_TO_S116=null;
        Token LPAREN117=null;
        Token COMMA119=null;
        Token RPAREN121=null;
        Token FUNCTION_N_SPLUS_TO_S122=null;
        Token LPAREN123=null;
        Token COMMA125=null;
        Token RPAREN127=null;
        Token FUNCTION_S_N1OR2_TO_S128=null;
        Token LPAREN129=null;
        Token COMMA131=null;
        Token COMMA133=null;
        Token RPAREN135=null;
        Token FUNCTION_S_TO_S136=null;
        Token LPAREN137=null;
        Token RPAREN139=null;
        ExprGrammarParser.arithmeticExpression_return arithmeticExpression118 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression120 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression124 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression126 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression130 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression132 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression134 = null;

        ExprGrammarParser.arithmeticExpression_return arithmeticExpression138 = null;


        CommonTree STRING115_tree=null;
        CommonTree FUNCTION_S_SPLUS_TO_S116_tree=null;
        CommonTree LPAREN117_tree=null;
        CommonTree COMMA119_tree=null;
        CommonTree RPAREN121_tree=null;
        CommonTree FUNCTION_N_SPLUS_TO_S122_tree=null;
        CommonTree LPAREN123_tree=null;
        CommonTree COMMA125_tree=null;
        CommonTree RPAREN127_tree=null;
        CommonTree FUNCTION_S_N1OR2_TO_S128_tree=null;
        CommonTree LPAREN129_tree=null;
        CommonTree COMMA131_tree=null;
        CommonTree COMMA133_tree=null;
        CommonTree RPAREN135_tree=null;
        CommonTree FUNCTION_S_TO_S136_tree=null;
        CommonTree LPAREN137_tree=null;
        CommonTree RPAREN139_tree=null;

        try {
            // ExprGrammar.g:166:5: ( STRING | FUNCTION_S_SPLUS_TO_S LPAREN arithmeticExpression ( COMMA arithmeticExpression )+ RPAREN | FUNCTION_N_SPLUS_TO_S LPAREN arithmeticExpression ( COMMA arithmeticExpression )+ RPAREN | FUNCTION_S_N1OR2_TO_S LPAREN arithmeticExpression COMMA arithmeticExpression ( COMMA arithmeticExpression )? RPAREN | FUNCTION_S_TO_S LPAREN arithmeticExpression RPAREN )
            int alt17=5;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt17=1;
                }
                break;
            case FUNCTION_S_SPLUS_TO_S:
                {
                alt17=2;
                }
                break;
            case FUNCTION_N_SPLUS_TO_S:
                {
                alt17=3;
                }
                break;
            case FUNCTION_S_N1OR2_TO_S:
                {
                alt17=4;
                }
                break;
            case FUNCTION_S_TO_S:
                {
                alt17=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }

            switch (alt17) {
                case 1 :
                    // ExprGrammar.g:166:7: STRING
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    STRING115=(Token)match(input,STRING,FOLLOW_STRING_in_stringExpr1116); 
                    STRING115_tree = (CommonTree)adaptor.create(STRING115);
                    adaptor.addChild(root_0, STRING115_tree);


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:167:7: FUNCTION_S_SPLUS_TO_S LPAREN arithmeticExpression ( COMMA arithmeticExpression )+ RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_S_SPLUS_TO_S116=(Token)match(input,FUNCTION_S_SPLUS_TO_S,FOLLOW_FUNCTION_S_SPLUS_TO_S_in_stringExpr1124); 
                    FUNCTION_S_SPLUS_TO_S116_tree = (CommonTree)adaptor.create(FUNCTION_S_SPLUS_TO_S116);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_S_SPLUS_TO_S116_tree, root_0);

                    LPAREN117=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_stringExpr1127); 
                    pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1130);
                    arithmeticExpression118=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression118.getTree());
                    // ExprGrammar.g:167:59: ( COMMA arithmeticExpression )+
                    int cnt14=0;
                    loop14:
                    do {
                        int alt14=2;
                        int LA14_0 = input.LA(1);

                        if ( (LA14_0==COMMA) ) {
                            alt14=1;
                        }


                        switch (alt14) {
                    	case 1 :
                    	    // ExprGrammar.g:167:60: COMMA arithmeticExpression
                    	    {
                    	    COMMA119=(Token)match(input,COMMA,FOLLOW_COMMA_in_stringExpr1133); 
                    	    pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1136);
                    	    arithmeticExpression120=arithmeticExpression();

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, arithmeticExpression120.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt14 >= 1 ) break loop14;
                                EarlyExitException eee =
                                    new EarlyExitException(14, input);
                                throw eee;
                        }
                        cnt14++;
                    } while (true);

                    RPAREN121=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_stringExpr1140); 

                    }
                    break;
                case 3 :
                    // ExprGrammar.g:168:7: FUNCTION_N_SPLUS_TO_S LPAREN arithmeticExpression ( COMMA arithmeticExpression )+ RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_N_SPLUS_TO_S122=(Token)match(input,FUNCTION_N_SPLUS_TO_S,FOLLOW_FUNCTION_N_SPLUS_TO_S_in_stringExpr1150); 
                    FUNCTION_N_SPLUS_TO_S122_tree = (CommonTree)adaptor.create(FUNCTION_N_SPLUS_TO_S122);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_N_SPLUS_TO_S122_tree, root_0);

                    LPAREN123=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_stringExpr1153); 
                    pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1156);
                    arithmeticExpression124=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression124.getTree());
                    // ExprGrammar.g:168:59: ( COMMA arithmeticExpression )+
                    int cnt15=0;
                    loop15:
                    do {
                        int alt15=2;
                        int LA15_0 = input.LA(1);

                        if ( (LA15_0==COMMA) ) {
                            alt15=1;
                        }


                        switch (alt15) {
                    	case 1 :
                    	    // ExprGrammar.g:168:60: COMMA arithmeticExpression
                    	    {
                    	    COMMA125=(Token)match(input,COMMA,FOLLOW_COMMA_in_stringExpr1159); 
                    	    pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1162);
                    	    arithmeticExpression126=arithmeticExpression();

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, arithmeticExpression126.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt15 >= 1 ) break loop15;
                                EarlyExitException eee =
                                    new EarlyExitException(15, input);
                                throw eee;
                        }
                        cnt15++;
                    } while (true);

                    RPAREN127=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_stringExpr1166); 

                    }
                    break;
                case 4 :
                    // ExprGrammar.g:169:7: FUNCTION_S_N1OR2_TO_S LPAREN arithmeticExpression COMMA arithmeticExpression ( COMMA arithmeticExpression )? RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_S_N1OR2_TO_S128=(Token)match(input,FUNCTION_S_N1OR2_TO_S,FOLLOW_FUNCTION_S_N1OR2_TO_S_in_stringExpr1176); 
                    FUNCTION_S_N1OR2_TO_S128_tree = (CommonTree)adaptor.create(FUNCTION_S_N1OR2_TO_S128);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_S_N1OR2_TO_S128_tree, root_0);

                    LPAREN129=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_stringExpr1179); 
                    pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1182);
                    arithmeticExpression130=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression130.getTree());
                    COMMA131=(Token)match(input,COMMA,FOLLOW_COMMA_in_stringExpr1184); 
                    pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1187);
                    arithmeticExpression132=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression132.getTree());
                    // ExprGrammar.g:169:87: ( COMMA arithmeticExpression )?
                    int alt16=2;
                    int LA16_0 = input.LA(1);

                    if ( (LA16_0==COMMA) ) {
                        alt16=1;
                    }
                    switch (alt16) {
                        case 1 :
                            // ExprGrammar.g:169:88: COMMA arithmeticExpression
                            {
                            COMMA133=(Token)match(input,COMMA,FOLLOW_COMMA_in_stringExpr1190); 
                            pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1193);
                            arithmeticExpression134=arithmeticExpression();

                            state._fsp--;

                            adaptor.addChild(root_0, arithmeticExpression134.getTree());

                            }
                            break;

                    }

                    RPAREN135=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_stringExpr1197); 

                    }
                    break;
                case 5 :
                    // ExprGrammar.g:170:7: FUNCTION_S_TO_S LPAREN arithmeticExpression RPAREN
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FUNCTION_S_TO_S136=(Token)match(input,FUNCTION_S_TO_S,FOLLOW_FUNCTION_S_TO_S_in_stringExpr1206); 
                    FUNCTION_S_TO_S136_tree = (CommonTree)adaptor.create(FUNCTION_S_TO_S136);
                    root_0 = (CommonTree)adaptor.becomeRoot(FUNCTION_S_TO_S136_tree, root_0);

                    LPAREN137=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_stringExpr1209); 
                    pushFollow(FOLLOW_arithmeticExpression_in_stringExpr1212);
                    arithmeticExpression138=arithmeticExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, arithmeticExpression138.getTree());
                    RPAREN139=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_stringExpr1214); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "stringExpr"

    public static class unaryExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryExpression"
    // ExprGrammar.g:172:1: unaryExpression : ( primaryExpression | unaryOperator unaryExpression );
    public final ExprGrammarParser.unaryExpression_return unaryExpression() throws RecognitionException {
        ExprGrammarParser.unaryExpression_return retval = new ExprGrammarParser.unaryExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        ExprGrammarParser.primaryExpression_return primaryExpression140 = null;

        ExprGrammarParser.unaryOperator_return unaryOperator141 = null;

        ExprGrammarParser.unaryExpression_return unaryExpression142 = null;



        try {
            // ExprGrammar.g:173:2: ( primaryExpression | unaryOperator unaryExpression )
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==LPAREN||LA18_0==DATACOLUMNNAME||(LA18_0>=TRUE && LA18_0<=IF)||(LA18_0>=STRING && LA18_0<=FUNCTION_S_TO_S)) ) {
                alt18=1;
            }
            else if ( ((LA18_0>=ADD && LA18_0<=SUB)||LA18_0==NOT) ) {
                alt18=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;
            }
            switch (alt18) {
                case 1 :
                    // ExprGrammar.g:173:4: primaryExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression1229);
                    primaryExpression140=primaryExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, primaryExpression140.getTree());

                    }
                    break;
                case 2 :
                    // ExprGrammar.g:174:4: unaryOperator unaryExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_unaryOperator_in_unaryExpression1234);
                    unaryOperator141=unaryOperator();

                    state._fsp--;

                    root_0 = (CommonTree)adaptor.becomeRoot(unaryOperator141.getTree(), root_0);
                    pushFollow(FOLLOW_unaryExpression_in_unaryExpression1237);
                    unaryExpression142=unaryExpression();

                    state._fsp--;

                    adaptor.addChild(root_0, unaryExpression142.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unaryExpression"

    public static class unaryOperator_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryOperator"
    // ExprGrammar.g:177:1: unaryOperator : ( NOT | op= ADD | op= SUB );
    public final ExprGrammarParser.unaryOperator_return unaryOperator() throws RecognitionException {
        ExprGrammarParser.unaryOperator_return retval = new ExprGrammarParser.unaryOperator_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token op=null;
        Token NOT143=null;

        CommonTree op_tree=null;
        CommonTree NOT143_tree=null;

        try {
            // ExprGrammar.g:178:2: ( NOT | op= ADD | op= SUB )
            int alt19=3;
            switch ( input.LA(1) ) {
            case NOT:
                {
                alt19=1;
                }
                break;
            case ADD:
                {
                alt19=2;
                }
                break;
            case SUB:
                {
                alt19=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;
            }

            switch (alt19) {
                case 1 :
                    // ExprGrammar.g:178:4: NOT
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    NOT143=(Token)match(input,NOT,FOLLOW_NOT_in_unaryOperator1249); 
                    NOT143_tree = (CommonTree)adaptor.create(NOT143);
                    adaptor.addChild(root_0, NOT143_tree);


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:179:7: op= ADD
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    op=(Token)match(input,ADD,FOLLOW_ADD_in_unaryOperator1259); 
                    op_tree = (CommonTree)adaptor.create(op);
                    adaptor.addChild(root_0, op_tree);

                     op.setType(POS); 

                    }
                    break;
                case 3 :
                    // ExprGrammar.g:180:4: op= SUB
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    op=(Token)match(input,SUB,FOLLOW_SUB_in_unaryOperator1268); 
                    op_tree = (CommonTree)adaptor.create(op);
                    adaptor.addChild(root_0, op_tree);

                     op.setType(NEG); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unaryOperator"

    public static class multiplicativeExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multiplicativeExpression"
    // ExprGrammar.g:183:1: multiplicativeExpression : unaryExpression ( ( MUL | DIV | MOD ) unaryExpression )* ;
    public final ExprGrammarParser.multiplicativeExpression_return multiplicativeExpression() throws RecognitionException {
        ExprGrammarParser.multiplicativeExpression_return retval = new ExprGrammarParser.multiplicativeExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set145=null;
        ExprGrammarParser.unaryExpression_return unaryExpression144 = null;

        ExprGrammarParser.unaryExpression_return unaryExpression146 = null;


        CommonTree set145_tree=null;

        try {
            // ExprGrammar.g:184:2: ( unaryExpression ( ( MUL | DIV | MOD ) unaryExpression )* )
            // ExprGrammar.g:184:4: unaryExpression ( ( MUL | DIV | MOD ) unaryExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression1281);
            unaryExpression144=unaryExpression();

            state._fsp--;

            adaptor.addChild(root_0, unaryExpression144.getTree());
            // ExprGrammar.g:184:20: ( ( MUL | DIV | MOD ) unaryExpression )*
            loop20:
            do {
                int alt20=2;
                int LA20_0 = input.LA(1);

                if ( ((LA20_0>=MUL && LA20_0<=MOD)||LA20_0==DIV) ) {
                    alt20=1;
                }


                switch (alt20) {
            	case 1 :
            	    // ExprGrammar.g:184:22: ( MUL | DIV | MOD ) unaryExpression
            	    {
            	    set145=(Token)input.LT(1);
            	    set145=(Token)input.LT(1);
            	    if ( (input.LA(1)>=MUL && input.LA(1)<=MOD)||input.LA(1)==DIV ) {
            	        input.consume();
            	        root_0 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(set145), root_0);
            	        state.errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression1300);
            	    unaryExpression146=unaryExpression();

            	    state._fsp--;

            	    adaptor.addChild(root_0, unaryExpression146.getTree());

            	    }
            	    break;

            	default :
            	    break loop20;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multiplicativeExpression"

    public static class additiveExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "additiveExpression"
    // ExprGrammar.g:187:1: additiveExpression : multiplicativeExpression ( ( ADD | SUB ) multiplicativeExpression )* ;
    public final ExprGrammarParser.additiveExpression_return additiveExpression() throws RecognitionException {
        ExprGrammarParser.additiveExpression_return retval = new ExprGrammarParser.additiveExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set148=null;
        ExprGrammarParser.multiplicativeExpression_return multiplicativeExpression147 = null;

        ExprGrammarParser.multiplicativeExpression_return multiplicativeExpression149 = null;


        CommonTree set148_tree=null;

        try {
            // ExprGrammar.g:188:2: ( multiplicativeExpression ( ( ADD | SUB ) multiplicativeExpression )* )
            // ExprGrammar.g:188:4: multiplicativeExpression ( ( ADD | SUB ) multiplicativeExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression1314);
            multiplicativeExpression147=multiplicativeExpression();

            state._fsp--;

            adaptor.addChild(root_0, multiplicativeExpression147.getTree());
            // ExprGrammar.g:188:29: ( ( ADD | SUB ) multiplicativeExpression )*
            loop21:
            do {
                int alt21=2;
                int LA21_0 = input.LA(1);

                if ( ((LA21_0>=ADD && LA21_0<=SUB)) ) {
                    alt21=1;
                }


                switch (alt21) {
            	case 1 :
            	    // ExprGrammar.g:188:31: ( ADD | SUB ) multiplicativeExpression
            	    {
            	    set148=(Token)input.LT(1);
            	    set148=(Token)input.LT(1);
            	    if ( (input.LA(1)>=ADD && input.LA(1)<=SUB) ) {
            	        input.consume();
            	        root_0 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(set148), root_0);
            	        state.errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression1329);
            	    multiplicativeExpression149=multiplicativeExpression();

            	    state._fsp--;

            	    adaptor.addChild(root_0, multiplicativeExpression149.getTree());

            	    }
            	    break;

            	default :
            	    break loop21;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "additiveExpression"

    public static class relationalExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationalExpression"
    // ExprGrammar.g:191:1: relationalExpression : additiveExpression ( ( LT | GT | LTE | GTE ) additiveExpression )* ;
    public final ExprGrammarParser.relationalExpression_return relationalExpression() throws RecognitionException {
        ExprGrammarParser.relationalExpression_return retval = new ExprGrammarParser.relationalExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set151=null;
        ExprGrammarParser.additiveExpression_return additiveExpression150 = null;

        ExprGrammarParser.additiveExpression_return additiveExpression152 = null;


        CommonTree set151_tree=null;

        try {
            // ExprGrammar.g:192:2: ( additiveExpression ( ( LT | GT | LTE | GTE ) additiveExpression )* )
            // ExprGrammar.g:192:4: additiveExpression ( ( LT | GT | LTE | GTE ) additiveExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_additiveExpression_in_relationalExpression1343);
            additiveExpression150=additiveExpression();

            state._fsp--;

            adaptor.addChild(root_0, additiveExpression150.getTree());
            // ExprGrammar.g:192:23: ( ( LT | GT | LTE | GTE ) additiveExpression )*
            loop22:
            do {
                int alt22=2;
                int LA22_0 = input.LA(1);

                if ( ((LA22_0>=LT && LA22_0<=GTE)) ) {
                    alt22=1;
                }


                switch (alt22) {
            	case 1 :
            	    // ExprGrammar.g:192:25: ( LT | GT | LTE | GTE ) additiveExpression
            	    {
            	    set151=(Token)input.LT(1);
            	    set151=(Token)input.LT(1);
            	    if ( (input.LA(1)>=LT && input.LA(1)<=GTE) ) {
            	        input.consume();
            	        root_0 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(set151), root_0);
            	        state.errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    pushFollow(FOLLOW_additiveExpression_in_relationalExpression1367);
            	    additiveExpression152=additiveExpression();

            	    state._fsp--;

            	    adaptor.addChild(root_0, additiveExpression152.getTree());

            	    }
            	    break;

            	default :
            	    break loop22;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationalExpression"

    public static class equalityExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "equalityExpression"
    // ExprGrammar.g:195:1: equalityExpression : relationalExpression ( ( EQ | NEQ ) relationalExpression )* ;
    public final ExprGrammarParser.equalityExpression_return equalityExpression() throws RecognitionException {
        ExprGrammarParser.equalityExpression_return retval = new ExprGrammarParser.equalityExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set154=null;
        ExprGrammarParser.relationalExpression_return relationalExpression153 = null;

        ExprGrammarParser.relationalExpression_return relationalExpression155 = null;


        CommonTree set154_tree=null;

        try {
            // ExprGrammar.g:196:2: ( relationalExpression ( ( EQ | NEQ ) relationalExpression )* )
            // ExprGrammar.g:196:4: relationalExpression ( ( EQ | NEQ ) relationalExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_relationalExpression_in_equalityExpression1381);
            relationalExpression153=relationalExpression();

            state._fsp--;

            adaptor.addChild(root_0, relationalExpression153.getTree());
            // ExprGrammar.g:196:25: ( ( EQ | NEQ ) relationalExpression )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( ((LA23_0>=EQ && LA23_0<=NEQ)) ) {
                    alt23=1;
                }


                switch (alt23) {
            	case 1 :
            	    // ExprGrammar.g:196:27: ( EQ | NEQ ) relationalExpression
            	    {
            	    set154=(Token)input.LT(1);
            	    set154=(Token)input.LT(1);
            	    if ( (input.LA(1)>=EQ && input.LA(1)<=NEQ) ) {
            	        input.consume();
            	        root_0 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(set154), root_0);
            	        state.errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    pushFollow(FOLLOW_relationalExpression_in_equalityExpression1396);
            	    relationalExpression155=relationalExpression();

            	    state._fsp--;

            	    adaptor.addChild(root_0, relationalExpression155.getTree());

            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "equalityExpression"

    public static class logicalANDExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "logicalANDExpression"
    // ExprGrammar.g:199:1: logicalANDExpression : equalityExpression ( LAND equalityExpression )* ;
    public final ExprGrammarParser.logicalANDExpression_return logicalANDExpression() throws RecognitionException {
        ExprGrammarParser.logicalANDExpression_return retval = new ExprGrammarParser.logicalANDExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LAND157=null;
        ExprGrammarParser.equalityExpression_return equalityExpression156 = null;

        ExprGrammarParser.equalityExpression_return equalityExpression158 = null;


        CommonTree LAND157_tree=null;

        try {
            // ExprGrammar.g:200:2: ( equalityExpression ( LAND equalityExpression )* )
            // ExprGrammar.g:200:4: equalityExpression ( LAND equalityExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_equalityExpression_in_logicalANDExpression1410);
            equalityExpression156=equalityExpression();

            state._fsp--;

            adaptor.addChild(root_0, equalityExpression156.getTree());
            // ExprGrammar.g:200:23: ( LAND equalityExpression )*
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==LAND) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // ExprGrammar.g:200:25: LAND equalityExpression
            	    {
            	    LAND157=(Token)match(input,LAND,FOLLOW_LAND_in_logicalANDExpression1414); 
            	    LAND157_tree = (CommonTree)adaptor.create(LAND157);
            	    root_0 = (CommonTree)adaptor.becomeRoot(LAND157_tree, root_0);

            	    pushFollow(FOLLOW_equalityExpression_in_logicalANDExpression1417);
            	    equalityExpression158=equalityExpression();

            	    state._fsp--;

            	    adaptor.addChild(root_0, equalityExpression158.getTree());

            	    }
            	    break;

            	default :
            	    break loop24;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "logicalANDExpression"

    public static class logicalORExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "logicalORExpression"
    // ExprGrammar.g:203:1: logicalORExpression : logicalANDExpression ( LOR logicalANDExpression )* ;
    public final ExprGrammarParser.logicalORExpression_return logicalORExpression() throws RecognitionException {
        ExprGrammarParser.logicalORExpression_return retval = new ExprGrammarParser.logicalORExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LOR160=null;
        ExprGrammarParser.logicalANDExpression_return logicalANDExpression159 = null;

        ExprGrammarParser.logicalANDExpression_return logicalANDExpression161 = null;


        CommonTree LOR160_tree=null;

        try {
            // ExprGrammar.g:204:2: ( logicalANDExpression ( LOR logicalANDExpression )* )
            // ExprGrammar.g:204:4: logicalANDExpression ( LOR logicalANDExpression )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_logicalANDExpression_in_logicalORExpression1432);
            logicalANDExpression159=logicalANDExpression();

            state._fsp--;

            adaptor.addChild(root_0, logicalANDExpression159.getTree());
            // ExprGrammar.g:204:25: ( LOR logicalANDExpression )*
            loop25:
            do {
                int alt25=2;
                int LA25_0 = input.LA(1);

                if ( (LA25_0==LOR) ) {
                    alt25=1;
                }


                switch (alt25) {
            	case 1 :
            	    // ExprGrammar.g:204:27: LOR logicalANDExpression
            	    {
            	    LOR160=(Token)match(input,LOR,FOLLOW_LOR_in_logicalORExpression1436); 
            	    LOR160_tree = (CommonTree)adaptor.create(LOR160);
            	    root_0 = (CommonTree)adaptor.becomeRoot(LOR160_tree, root_0);

            	    pushFollow(FOLLOW_logicalANDExpression_in_logicalORExpression1439);
            	    logicalANDExpression161=logicalANDExpression();

            	    state._fsp--;

            	    adaptor.addChild(root_0, logicalANDExpression161.getTree());

            	    }
            	    break;

            	default :
            	    break loop25;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "logicalORExpression"

    public static class arithmeticExpression_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arithmeticExpression"
    // ExprGrammar.g:207:1: arithmeticExpression : logicalORExpression ;
    public final ExprGrammarParser.arithmeticExpression_return arithmeticExpression() throws RecognitionException {
        ExprGrammarParser.arithmeticExpression_return retval = new ExprGrammarParser.arithmeticExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        ExprGrammarParser.logicalORExpression_return logicalORExpression162 = null;



        try {
            // ExprGrammar.g:208:2: ( logicalORExpression )
            // ExprGrammar.g:208:4: logicalORExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_logicalORExpression_in_arithmeticExpression1456);
            logicalORExpression162=logicalORExpression();

            state._fsp--;

            adaptor.addChild(root_0, logicalORExpression162.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "arithmeticExpression"

    // Delegated rules


 

    public static final BitSet FOLLOW_value_in_arg495 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arg_in_args513 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_args516 = new BitSet(new long[]{0x03FFFFFF800C0050L});
    public static final BitSet FOLLOW_arg_in_args519 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_arithmeticExpression_in_value538 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_geometry_in_value546 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_list_in_value554 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACE_in_list571 = new BitSet(new long[]{0x03FFFFFF800C0070L});
    public static final BitSet FOLLOW_list_content_in_list573 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_RBRACE_in_list576 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_value_in_list_content600 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_list_content603 = new BitSet(new long[]{0x03FFFFFF800C0050L});
    public static final BitSet FOLLOW_value_in_list_content606 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_TRUE_in_primaryExpression627 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_primaryExpression635 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATACOLUMNNAME_in_primaryExpression643 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_primaryExpression651 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_primaryExpression655 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arithmeticFunctionCall_in_primaryExpression663 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_primaryExpression671 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_primaryExpression674 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_primaryExpression676 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringExpr_in_primaryExpression685 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_classificationCall_in_primaryExpression693 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_CLASSIF_NO_CLASS_NUMBER_in_classificationCall711 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_classificationCall715 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_DATACOLUMNNAME_in_classificationCall718 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_COMMA_in_classificationCall721 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_classificationCall724 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_classificationCall728 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_CLASSIF_in_classificationCall738 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_classificationCall742 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_DATACOLUMNNAME_in_classificationCall745 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_classificationCall747 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_INT_in_classificationCall750 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_COMMA_in_classificationCall754 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_classificationCall757 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_classificationCall761 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_CLASSIF_CUSTOM_in_classificationCall771 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_classificationCall775 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_DATACOLUMNNAME_in_classificationCall778 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_classificationCall781 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_classificationCall784 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_RPAREN_in_classificationCall788 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_N_TO_N_in_arithmeticFunctionCall806 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_arithmeticFunctionCall809 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall812 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_arithmeticFunctionCall814 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_N1OR2_TO_N_in_arithmeticFunctionCall824 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_arithmeticFunctionCall827 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall830 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_COMMA_in_arithmeticFunctionCall833 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall836 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_arithmeticFunctionCall840 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_G_TO_N_in_arithmeticFunctionCall850 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_arithmeticFunctionCall853 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_arithmeticFunctionCall856 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_arithmeticFunctionCall858 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_G_G_TO_N_in_arithmeticFunctionCall867 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_arithmeticFunctionCall870 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_arithmeticFunctionCall873 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_arithmeticFunctionCall875 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_arithmeticFunctionCall878 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_arithmeticFunctionCall880 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_S_TO_N_in_arithmeticFunctionCall889 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_arithmeticFunctionCall892 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall895 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_arithmeticFunctionCall897 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_S_S_TO_N_in_arithmeticFunctionCall907 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_arithmeticFunctionCall910 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall913 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_arithmeticFunctionCall915 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall918 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_arithmeticFunctionCall920 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_arithmeticFunctionCall930 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_arithmeticFunctionCall933 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_logicalORExpression_in_arithmeticFunctionCall936 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_arithmeticFunctionCall938 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall941 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_arithmeticFunctionCall943 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_arithmeticFunctionCall946 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_arithmeticFunctionCall948 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OMCOLUMNNAME_in_geometry971 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_geometryFunctionCall_in_geometry979 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_N_N_TO_G_in_geometryFunctionCall996 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_geometryFunctionCall999 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_geometryFunctionCall1002 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_geometryFunctionCall1004 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_geometryFunctionCall1007 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_geometryFunctionCall1009 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_G_TO_G_in_geometryFunctionCall1019 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_geometryFunctionCall1022 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_geometryFunctionCall1025 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_geometryFunctionCall1027 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_G_N_TO_G_in_geometryFunctionCall1037 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_geometryFunctionCall1040 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_geometryFunctionCall1043 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_geometryFunctionCall1045 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_geometryFunctionCall1048 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_geometryFunctionCall1050 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_G_N_N_TO_G_in_geometryFunctionCall1060 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_geometryFunctionCall1063 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_geometryFunctionCall1066 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_geometryFunctionCall1068 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_geometryFunctionCall1071 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_geometryFunctionCall1073 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_geometryFunctionCall1076 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_geometryFunctionCall1078 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_G_G_TO_G_in_geometryFunctionCall1088 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_geometryFunctionCall1091 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_geometryFunctionCall1094 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_geometryFunctionCall1096 = new BitSet(new long[]{0x000F800100000000L});
    public static final BitSet FOLLOW_geometry_in_geometryFunctionCall1099 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_geometryFunctionCall1101 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_stringExpr1116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_S_SPLUS_TO_S_in_stringExpr1124 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_stringExpr1127 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1130 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_stringExpr1133 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1136 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_RPAREN_in_stringExpr1140 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_N_SPLUS_TO_S_in_stringExpr1150 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_stringExpr1153 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1156 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_stringExpr1159 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1162 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_RPAREN_in_stringExpr1166 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_S_N1OR2_TO_S_in_stringExpr1176 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_stringExpr1179 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1182 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_stringExpr1184 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1187 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_COMMA_in_stringExpr1190 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1193 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_stringExpr1197 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNCTION_S_TO_S_in_stringExpr1206 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_LPAREN_in_stringExpr1209 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_arithmeticExpression_in_stringExpr1212 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RPAREN_in_stringExpr1214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression1229 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unaryOperator_in_unaryExpression1234 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_unaryExpression_in_unaryExpression1237 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NOT_in_unaryOperator1249 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADD_in_unaryOperator1259 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SUB_in_unaryOperator1268 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression1281 = new BitSet(new long[]{0x0000000004300002L});
    public static final BitSet FOLLOW_set_in_multiplicativeExpression1285 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression1300 = new BitSet(new long[]{0x0000000004300002L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression1314 = new BitSet(new long[]{0x00000000000C0002L});
    public static final BitSet FOLLOW_set_in_additiveExpression1318 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression1329 = new BitSet(new long[]{0x00000000000C0002L});
    public static final BitSet FOLLOW_additiveExpression_in_relationalExpression1343 = new BitSet(new long[]{0x0000000000007802L});
    public static final BitSet FOLLOW_set_in_relationalExpression1347 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_additiveExpression_in_relationalExpression1367 = new BitSet(new long[]{0x0000000000007802L});
    public static final BitSet FOLLOW_relationalExpression_in_equalityExpression1381 = new BitSet(new long[]{0x0000000000018002L});
    public static final BitSet FOLLOW_set_in_equalityExpression1385 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_relationalExpression_in_equalityExpression1396 = new BitSet(new long[]{0x0000000000018002L});
    public static final BitSet FOLLOW_equalityExpression_in_logicalANDExpression1410 = new BitSet(new long[]{0x0400000000000002L});
    public static final BitSet FOLLOW_LAND_in_logicalANDExpression1414 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_equalityExpression_in_logicalANDExpression1417 = new BitSet(new long[]{0x0400000000000002L});
    public static final BitSet FOLLOW_logicalANDExpression_in_logicalORExpression1432 = new BitSet(new long[]{0x0800000000000002L});
    public static final BitSet FOLLOW_LOR_in_logicalORExpression1436 = new BitSet(new long[]{0x03F07FFE800C0040L});
    public static final BitSet FOLLOW_logicalANDExpression_in_logicalORExpression1439 = new BitSet(new long[]{0x0800000000000002L});
    public static final BitSet FOLLOW_logicalORExpression_in_arithmeticExpression1456 = new BitSet(new long[]{0x0000000000000002L});

}