// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/** @deprecated */
package fr.unicaen.openmap.dataStorage.gui;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;

public class CSVSaveFileChooser extends JFileChooser{

    public static final String CSV = "csv";
    public static final String CSZ = "csv.gz";
    public static final String GZ = "gz";
	
    public CSVSaveFileChooser(String path){
	super(path);
	FileNameExtensionFilter filter = 
	    new FileNameExtensionFilter("CSV files", CSV);
        FileNameExtensionFilter filterz = 
	    new FileNameExtensionFilter("Compressed CSV files", CSZ);
        setFileFilter(filter);
        addChoosableFileFilter(filterz);
        addChoosableFileFilter(filter);
    }    
}
