// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.kml;

public class KMLConstants {
	
	
    public final  String KML_NAMESPACE_URI =
        "http://earth.google.com/kml/2.1";
    
    public final static String ENCODING = "UTF-8";
    
    public final static String IMAGEFORMAT_KML = "kml";
    
	public final  static String KML_POLY = "Polygon";
	
	public final  static String KML_POINT = "Point";
	
	public final  static String KML_LINE = "Line";
	
	public final  static String KML_PLACEMARK = "Placemark";

	public final static String SPACE = " ";
	
	public final static String COMA = ",";
	
	public final static String KML_NAME = "name";
	
	public final static String KML_EXTRUDE = "extrude";
	
	public final static String KML_ALTITUDE_MODE = "altitudeMode";
	
	public final static String KML_RELATIVE_GROUND = "relativeToGround";
	
	public final static String KML_TESSELATE = "tesselate";
	
	public final static String KML_LINEAR_RING= "LinearRing";
	
	public final static String KML_OUTER_BOUNDARY= "outerBoundaryIs";
	
	public final static String KML_COORDINATES= "coordinates";	
	
	public final static String DESCRIPTION= "description";	
	
	public final static String KML_STYLE_URL ="styleUrl";
	
	public final static String KML_STYLE ="Style";
	
	public final static String KML_POLY_STYLE = "PolyStyle";
	
	public final static String KML_ID ="id";
}
