// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * LayerConstants.java
 *
 * Created on 1 mars 2006, 15:50
 *
 */

package fr.unicaen.openmap.layer.dataDisplayLayer;

/**
 *
 * @author christof
 */
public class LayerConstants {
  
    // nothing to draw when Drawing name mode is set
    public static final int DRAWING_NAME_MODE_OFF = 0;
    // draw the name of all omgraphics
    public static final int DRAWING_NAME_MODE_ON = 1;
    // draw only name of the selected omgraphics
    public static final int DRAWING_NAME_MODE_SELECTED = 2;
    
}
