// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage;

import fr.unicaen.openmap.dataStorage.SortDataStorage.Format;
import java.util.Comparator;

public abstract class DataObjectComparator  implements Comparator<DataObject>{

	
	protected SortDataStorage.Format format;
	protected String sortParameter;

    public Format getFormat() {
        return format;
    }


    public String getSortParameter() {
        return sortParameter;
    }

	public DataObjectComparator(String sortParameter, SortDataStorage.Format format){
		this.sortParameter = sortParameter;
		this.format = format;
	}
	
	/*public int compare(DataObject d1, DataObject d2) {
		Object data1 = d1.getData(sortParameter);
		Object data2 = d2.getData(sortParameter);
		
		if(format == SortDataStorage.Format.NUMERIC){
			try{
			return ((Double)data1).compareTo((Double)data2);}
			catch(ClassCastException e){
				Double double1 = Double.parseDouble(data1.toString());
				Double double2 = Double.parseDouble(data2.toString());
				return double1.compareTo(double2);
			}
		}
		if(format == SortDataStorage.Format.STRING){
			return (data1.toString()).compareTo(data2.toString());
		}
		return 0;
	}*/

}
