// $ANTLR 3.3 Nov 30, 2010 12:45:30 ExprGrammar.g 2012-09-07 18:40:53

    package  fr.unicaen.openmap.dataStorage.expr;
    import fr.unicaen.openmap.dataStorage.gui.DataTableModel;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class ExprGrammarLexer extends Lexer {
    public static final int EOF=-1;
    public static final int LBRACE=4;
    public static final int RBRACE=5;
    public static final int LPAREN=6;
    public static final int RPAREN=7;
    public static final int DOT=8;
    public static final int SEMIC=9;
    public static final int COMMA=10;
    public static final int LT=11;
    public static final int GT=12;
    public static final int LTE=13;
    public static final int GTE=14;
    public static final int EQ=15;
    public static final int NEQ=16;
    public static final int NOTEQ=17;
    public static final int ADD=18;
    public static final int SUB=19;
    public static final int MUL=20;
    public static final int MOD=21;
    public static final int AND=22;
    public static final int OR=23;
    public static final int XOR=24;
    public static final int INV=25;
    public static final int DIV=26;
    public static final int ARGS=27;
    public static final int LIST=28;
    public static final int NEG=29;
    public static final int POS=30;
    public static final int DATACOLUMNNAME=31;
    public static final int OMCOLUMNNAME=32;
    public static final int TRUE=33;
    public static final int FALSE=34;
    public static final int INT=35;
    public static final int FLOAT=36;
    public static final int FUNCTION_CLASSIF_NO_CLASS_NUMBER=37;
    public static final int FUNCTION_CLASSIF=38;
    public static final int FUNCTION_CLASSIF_CUSTOM=39;
    public static final int FUNCTION_N_TO_N=40;
    public static final int FUNCTION_N1OR2_TO_N=41;
    public static final int FUNCTION_G_TO_N=42;
    public static final int FUNCTION_G_G_TO_N=43;
    public static final int FUNCTION_S_TO_N=44;
    public static final int FUNCTION_S_S_TO_N=45;
    public static final int IF=46;
    public static final int FUNCTION_N_N_TO_G=47;
    public static final int FUNCTION_G_TO_G=48;
    public static final int FUNCTION_G_N_TO_G=49;
    public static final int FUNCTION_G_N_N_TO_G=50;
    public static final int FUNCTION_G_G_TO_G=51;
    public static final int STRING=52;
    public static final int FUNCTION_S_SPLUS_TO_S=53;
    public static final int FUNCTION_N_SPLUS_TO_S=54;
    public static final int FUNCTION_S_N1OR2_TO_S=55;
    public static final int FUNCTION_S_TO_S=56;
    public static final int NOT=57;
    public static final int LAND=58;
    public static final int LOR=59;
    public static final int Letter=60;
    public static final int JavaIDDigit=61;
    public static final int ID=62;
    public static final int EXPONENT=63;
    public static final int COMMENT=64;
    public static final int WS=65;
    public static final int ESC_SEQ=66;
    public static final int HEX_DIGIT=67;
    public static final int UNICODE_ESC=68;
    public static final int OCTAL_ESC=69;

        protected DataTableModel dtm;
        public ExprGrammarLexer(CharStream input, DataTableModel dtm) {
                this(input);
                this.dtm = dtm;
        }
        public boolean isDataColumName(String s) {
            if (dtm == null)
                return false;
            for(String name : dtm.getDataColumnNames())
                if (name.equals(s)) 
                    return true;
            return false;
        }  
        public boolean isOMColumName(String s) {
            if (dtm == null)
                return false;
            for(String name : dtm.getOMColumnNames())
                if (name.equals(s)) 
                    return true;
            return false;
        }


    // delegates
    // delegators

    public ExprGrammarLexer() {;} 
    public ExprGrammarLexer(CharStream input) {
        this(input, new RecognizerSharedState());
    }
    public ExprGrammarLexer(CharStream input, RecognizerSharedState state) {
        super(input,state);

    }
    public String getGrammarFileName() { return "ExprGrammar.g"; }

    // $ANTLR start "LBRACE"
    public final void mLBRACE() throws RecognitionException {
        try {
            int _type = LBRACE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:35:8: ( '{' )
            // ExprGrammar.g:35:10: '{'
            {
            match('{'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LBRACE"

    // $ANTLR start "RBRACE"
    public final void mRBRACE() throws RecognitionException {
        try {
            int _type = RBRACE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:36:8: ( '}' )
            // ExprGrammar.g:36:10: '}'
            {
            match('}'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RBRACE"

    // $ANTLR start "LPAREN"
    public final void mLPAREN() throws RecognitionException {
        try {
            int _type = LPAREN;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:37:8: ( '(' )
            // ExprGrammar.g:37:10: '('
            {
            match('('); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LPAREN"

    // $ANTLR start "RPAREN"
    public final void mRPAREN() throws RecognitionException {
        try {
            int _type = RPAREN;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:38:8: ( ')' )
            // ExprGrammar.g:38:10: ')'
            {
            match(')'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RPAREN"

    // $ANTLR start "DOT"
    public final void mDOT() throws RecognitionException {
        try {
            int _type = DOT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:39:5: ( '.' )
            // ExprGrammar.g:39:7: '.'
            {
            match('.'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "DOT"

    // $ANTLR start "SEMIC"
    public final void mSEMIC() throws RecognitionException {
        try {
            int _type = SEMIC;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:40:7: ( ';' )
            // ExprGrammar.g:40:9: ';'
            {
            match(';'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "SEMIC"

    // $ANTLR start "COMMA"
    public final void mCOMMA() throws RecognitionException {
        try {
            int _type = COMMA;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:41:7: ( ',' )
            // ExprGrammar.g:41:9: ','
            {
            match(','); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "COMMA"

    // $ANTLR start "LT"
    public final void mLT() throws RecognitionException {
        try {
            int _type = LT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:42:4: ( '<' )
            // ExprGrammar.g:42:6: '<'
            {
            match('<'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LT"

    // $ANTLR start "GT"
    public final void mGT() throws RecognitionException {
        try {
            int _type = GT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:43:4: ( '>' )
            // ExprGrammar.g:43:6: '>'
            {
            match('>'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "GT"

    // $ANTLR start "LTE"
    public final void mLTE() throws RecognitionException {
        try {
            int _type = LTE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:44:5: ( '<=' )
            // ExprGrammar.g:44:7: '<='
            {
            match("<="); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LTE"

    // $ANTLR start "GTE"
    public final void mGTE() throws RecognitionException {
        try {
            int _type = GTE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:45:5: ( '>=' )
            // ExprGrammar.g:45:7: '>='
            {
            match(">="); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "GTE"

    // $ANTLR start "EQ"
    public final void mEQ() throws RecognitionException {
        try {
            int _type = EQ;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:46:4: ( '=' )
            // ExprGrammar.g:46:6: '='
            {
            match('='); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "EQ"

    // $ANTLR start "NEQ"
    public final void mNEQ() throws RecognitionException {
        try {
            int _type = NEQ;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:47:5: ( '<>' )
            // ExprGrammar.g:47:7: '<>'
            {
            match("<>"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "NEQ"

    // $ANTLR start "NOTEQ"
    public final void mNOTEQ() throws RecognitionException {
        try {
            int _type = NOTEQ;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:48:7: ( '!=' )
            // ExprGrammar.g:48:9: '!='
            {
            match("!="); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "NOTEQ"

    // $ANTLR start "ADD"
    public final void mADD() throws RecognitionException {
        try {
            int _type = ADD;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:49:5: ( '+' )
            // ExprGrammar.g:49:7: '+'
            {
            match('+'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ADD"

    // $ANTLR start "SUB"
    public final void mSUB() throws RecognitionException {
        try {
            int _type = SUB;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:50:5: ( '-' )
            // ExprGrammar.g:50:7: '-'
            {
            match('-'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "SUB"

    // $ANTLR start "MUL"
    public final void mMUL() throws RecognitionException {
        try {
            int _type = MUL;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:51:5: ( '*' )
            // ExprGrammar.g:51:7: '*'
            {
            match('*'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "MUL"

    // $ANTLR start "MOD"
    public final void mMOD() throws RecognitionException {
        try {
            int _type = MOD;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:52:5: ( '%' )
            // ExprGrammar.g:52:7: '%'
            {
            match('%'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "MOD"

    // $ANTLR start "AND"
    public final void mAND() throws RecognitionException {
        try {
            int _type = AND;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:53:5: ( '&' )
            // ExprGrammar.g:53:7: '&'
            {
            match('&'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "AND"

    // $ANTLR start "OR"
    public final void mOR() throws RecognitionException {
        try {
            int _type = OR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:54:4: ( '|' )
            // ExprGrammar.g:54:6: '|'
            {
            match('|'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "OR"

    // $ANTLR start "XOR"
    public final void mXOR() throws RecognitionException {
        try {
            int _type = XOR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:55:5: ( '^' )
            // ExprGrammar.g:55:7: '^'
            {
            match('^'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "XOR"

    // $ANTLR start "INV"
    public final void mINV() throws RecognitionException {
        try {
            int _type = INV;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:56:5: ( '~' )
            // ExprGrammar.g:56:7: '~'
            {
            match('~'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "INV"

    // $ANTLR start "DIV"
    public final void mDIV() throws RecognitionException {
        try {
            int _type = DIV;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:57:5: ( '/' )
            // ExprGrammar.g:57:7: '/'
            {
            match('/'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "DIV"

    // $ANTLR start "TRUE"
    public final void mTRUE() throws RecognitionException {
        try {
            int _type = TRUE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:214:6: ( 'TRUE' | 'true' )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0=='T') ) {
                alt1=1;
            }
            else if ( (LA1_0=='t') ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // ExprGrammar.g:214:8: 'TRUE'
                    {
                    match("TRUE"); 


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:214:17: 'true'
                    {
                    match("true"); 


                    }
                    break;

            }
            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "TRUE"

    // $ANTLR start "FALSE"
    public final void mFALSE() throws RecognitionException {
        try {
            int _type = FALSE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:216:7: ( 'FALSE' | 'false' )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0=='F') ) {
                alt2=1;
            }
            else if ( (LA2_0=='f') ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // ExprGrammar.g:216:9: 'FALSE'
                    {
                    match("FALSE"); 


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:216:19: 'false'
                    {
                    match("false"); 


                    }
                    break;

            }
            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FALSE"

    // $ANTLR start "FUNCTION_N_TO_N"
    public final void mFUNCTION_N_TO_N() throws RecognitionException {
        try {
            int _type = FUNCTION_N_TO_N;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:219:17: ( 'COS' )
            // ExprGrammar.g:219:19: 'COS'
            {
            match("COS"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_N_TO_N"

    // $ANTLR start "FUNCTION_N1OR2_TO_N"
    public final void mFUNCTION_N1OR2_TO_N() throws RecognitionException {
        try {
            int _type = FUNCTION_N1OR2_TO_N;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:220:21: ( 'ROUND' )
            // ExprGrammar.g:220:23: 'ROUND'
            {
            match("ROUND"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_N1OR2_TO_N"

    // $ANTLR start "FUNCTION_G_TO_N"
    public final void mFUNCTION_G_TO_N() throws RecognitionException {
        try {
            int _type = FUNCTION_G_TO_N;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:221:17: ( 'ST_AREA' )
            // ExprGrammar.g:221:19: 'ST_AREA'
            {
            match("ST_AREA"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_G_TO_N"

    // $ANTLR start "FUNCTION_G_G_TO_N"
    public final void mFUNCTION_G_G_TO_N() throws RecognitionException {
        try {
            int _type = FUNCTION_G_G_TO_N;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:222:19: ( 'CENTROIDDISTANCE' )
            // ExprGrammar.g:222:21: 'CENTROIDDISTANCE'
            {
            match("CENTROIDDISTANCE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_G_G_TO_N"

    // $ANTLR start "FUNCTION_N_N_TO_G"
    public final void mFUNCTION_N_N_TO_G() throws RecognitionException {
        try {
            int _type = FUNCTION_N_N_TO_G;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:223:19: ( 'MAKEPOINT' )
            // ExprGrammar.g:223:21: 'MAKEPOINT'
            {
            match("MAKEPOINT"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_N_N_TO_G"

    // $ANTLR start "FUNCTION_G_TO_G"
    public final void mFUNCTION_G_TO_G() throws RecognitionException {
        try {
            int _type = FUNCTION_G_TO_G;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:224:17: ( 'CENTROID' )
            // ExprGrammar.g:224:19: 'CENTROID'
            {
            match("CENTROID"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_G_TO_G"

    // $ANTLR start "FUNCTION_G_N_TO_G"
    public final void mFUNCTION_G_N_TO_G() throws RecognitionException {
        try {
            int _type = FUNCTION_G_N_TO_G;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:225:19: ( 'MAKEDISC' )
            // ExprGrammar.g:225:21: 'MAKEDISC'
            {
            match("MAKEDISC"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_G_N_TO_G"

    // $ANTLR start "FUNCTION_G_N_N_TO_G"
    public final void mFUNCTION_G_N_N_TO_G() throws RecognitionException {
        try {
            int _type = FUNCTION_G_N_N_TO_G;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:226:21: ( 'MAKERECT' )
            // ExprGrammar.g:226:23: 'MAKERECT'
            {
            match("MAKERECT"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_G_N_N_TO_G"

    // $ANTLR start "FUNCTION_G_G_TO_G"
    public final void mFUNCTION_G_G_TO_G() throws RecognitionException {
        try {
            int _type = FUNCTION_G_G_TO_G;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:227:19: ( 'ST_UNION' )
            // ExprGrammar.g:227:21: 'ST_UNION'
            {
            match("ST_UNION"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_G_G_TO_G"

    // $ANTLR start "FUNCTION_S_TO_N"
    public final void mFUNCTION_S_TO_N() throws RecognitionException {
        try {
            int _type = FUNCTION_S_TO_N;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:228:17: ( 'LENGTH' )
            // ExprGrammar.g:228:19: 'LENGTH'
            {
            match("LENGTH"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_S_TO_N"

    // $ANTLR start "FUNCTION_S_TO_S"
    public final void mFUNCTION_S_TO_S() throws RecognitionException {
        try {
            int _type = FUNCTION_S_TO_S;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:229:17: ( 'TRIM' )
            // ExprGrammar.g:229:19: 'TRIM'
            {
            match("TRIM"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_S_TO_S"

    // $ANTLR start "FUNCTION_S_SPLUS_TO_S"
    public final void mFUNCTION_S_SPLUS_TO_S() throws RecognitionException {
        try {
            int _type = FUNCTION_S_SPLUS_TO_S;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:230:23: ( 'CONCAT' )
            // ExprGrammar.g:230:25: 'CONCAT'
            {
            match("CONCAT"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_S_SPLUS_TO_S"

    // $ANTLR start "FUNCTION_N_SPLUS_TO_S"
    public final void mFUNCTION_N_SPLUS_TO_S() throws RecognitionException {
        try {
            int _type = FUNCTION_N_SPLUS_TO_S;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:231:23: ( 'CHOOSE' )
            // ExprGrammar.g:231:25: 'CHOOSE'
            {
            match("CHOOSE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_N_SPLUS_TO_S"

    // $ANTLR start "FUNCTION_S_N1OR2_TO_S"
    public final void mFUNCTION_S_N1OR2_TO_S() throws RecognitionException {
        try {
            int _type = FUNCTION_S_N1OR2_TO_S;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:232:23: ( 'SUBSTRING' )
            // ExprGrammar.g:232:25: 'SUBSTRING'
            {
            match("SUBSTRING"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_S_N1OR2_TO_S"

    // $ANTLR start "FUNCTION_S_S_TO_N"
    public final void mFUNCTION_S_S_TO_N() throws RecognitionException {
        try {
            int _type = FUNCTION_S_S_TO_N;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:233:19: ( 'MATCH' )
            // ExprGrammar.g:233:21: 'MATCH'
            {
            match("MATCH"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_S_S_TO_N"

    // $ANTLR start "FUNCTION_CLASSIF_NO_CLASS_NUMBER"
    public final void mFUNCTION_CLASSIF_NO_CLASS_NUMBER() throws RecognitionException {
        try {
            int _type = FUNCTION_CLASSIF_NO_CLASS_NUMBER;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:234:34: ( 'CL_DISCRETE' )
            // ExprGrammar.g:234:36: 'CL_DISCRETE'
            {
            match("CL_DISCRETE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_CLASSIF_NO_CLASS_NUMBER"

    // $ANTLR start "FUNCTION_CLASSIF"
    public final void mFUNCTION_CLASSIF() throws RecognitionException {
        try {
            int _type = FUNCTION_CLASSIF;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:235:18: ( 'CL_QUANTILE' )
            // ExprGrammar.g:235:20: 'CL_QUANTILE'
            {
            match("CL_QUANTILE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_CLASSIF"

    // $ANTLR start "FUNCTION_CLASSIF_CUSTOM"
    public final void mFUNCTION_CLASSIF_CUSTOM() throws RecognitionException {
        try {
            int _type = FUNCTION_CLASSIF_CUSTOM;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:236:25: ( 'CL_CUSTOM' )
            // ExprGrammar.g:236:27: 'CL_CUSTOM'
            {
            match("CL_CUSTOM"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FUNCTION_CLASSIF_CUSTOM"

    // $ANTLR start "OMCOLUMNNAME"
    public final void mOMCOLUMNNAME() throws RecognitionException {
        try {
            int _type = OMCOLUMNNAME;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:237:14: ( 'SHAPE' )
            // ExprGrammar.g:237:16: 'SHAPE'
            {
            match("SHAPE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "OMCOLUMNNAME"

    // $ANTLR start "DATACOLUMNNAME"
    public final void mDATACOLUMNNAME() throws RecognitionException {
        try {
            int _type = DATACOLUMNNAME;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:238:16: ( 'DATA' )
            // ExprGrammar.g:238:18: 'DATA'
            {
            match("DATA"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "DATACOLUMNNAME"

    // $ANTLR start "IF"
    public final void mIF() throws RecognitionException {
        try {
            int _type = IF;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:239:4: ( ( 'if' | 'IF' ) )
            // ExprGrammar.g:239:6: ( 'if' | 'IF' )
            {
            // ExprGrammar.g:239:6: ( 'if' | 'IF' )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0=='i') ) {
                alt3=1;
            }
            else if ( (LA3_0=='I') ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // ExprGrammar.g:239:7: 'if'
                    {
                    match("if"); 


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:239:12: 'IF'
                    {
                    match("IF"); 


                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "IF"

    // $ANTLR start "NOT"
    public final void mNOT() throws RecognitionException {
        try {
            int _type = NOT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:240:5: ( ( '!' | 'not' | 'NOT' ) )
            // ExprGrammar.g:240:7: ( '!' | 'not' | 'NOT' )
            {
            // ExprGrammar.g:240:7: ( '!' | 'not' | 'NOT' )
            int alt4=3;
            switch ( input.LA(1) ) {
            case '!':
                {
                alt4=1;
                }
                break;
            case 'n':
                {
                alt4=2;
                }
                break;
            case 'N':
                {
                alt4=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // ExprGrammar.g:240:8: '!'
                    {
                    match('!'); 

                    }
                    break;
                case 2 :
                    // ExprGrammar.g:240:12: 'not'
                    {
                    match("not"); 


                    }
                    break;
                case 3 :
                    // ExprGrammar.g:240:18: 'NOT'
                    {
                    match("NOT"); 


                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "NOT"

    // $ANTLR start "LAND"
    public final void mLAND() throws RecognitionException {
        try {
            int _type = LAND;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:241:6: ( ( '&&' | 'and' | 'AND' ) )
            // ExprGrammar.g:241:8: ( '&&' | 'and' | 'AND' )
            {
            // ExprGrammar.g:241:8: ( '&&' | 'and' | 'AND' )
            int alt5=3;
            switch ( input.LA(1) ) {
            case '&':
                {
                alt5=1;
                }
                break;
            case 'a':
                {
                alt5=2;
                }
                break;
            case 'A':
                {
                alt5=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // ExprGrammar.g:241:9: '&&'
                    {
                    match("&&"); 


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:241:14: 'and'
                    {
                    match("and"); 


                    }
                    break;
                case 3 :
                    // ExprGrammar.g:241:20: 'AND'
                    {
                    match("AND"); 


                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LAND"

    // $ANTLR start "LOR"
    public final void mLOR() throws RecognitionException {
        try {
            int _type = LOR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:242:5: ( ( '||' | 'or' | 'OR' ) )
            // ExprGrammar.g:242:7: ( '||' | 'or' | 'OR' )
            {
            // ExprGrammar.g:242:7: ( '||' | 'or' | 'OR' )
            int alt6=3;
            switch ( input.LA(1) ) {
            case '|':
                {
                alt6=1;
                }
                break;
            case 'o':
                {
                alt6=2;
                }
                break;
            case 'O':
                {
                alt6=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }

            switch (alt6) {
                case 1 :
                    // ExprGrammar.g:242:8: '||'
                    {
                    match("||"); 


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:242:13: 'or'
                    {
                    match("or"); 


                    }
                    break;
                case 3 :
                    // ExprGrammar.g:242:18: 'OR'
                    {
                    match("OR"); 


                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LOR"

    // $ANTLR start "ID"
    public final void mID() throws RecognitionException {
        try {
            int _type = ID;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:244:5: ( ( ( Letter ( Letter | JavaIDDigit | '/' )* ) | ( '`' ( . )* '`' ) ) )
            // ExprGrammar.g:244:7: ( ( Letter ( Letter | JavaIDDigit | '/' )* ) | ( '`' ( . )* '`' ) )
            {
            // ExprGrammar.g:244:7: ( ( Letter ( Letter | JavaIDDigit | '/' )* ) | ( '`' ( . )* '`' ) )
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0=='$'||(LA9_0>='A' && LA9_0<='Z')||LA9_0=='_'||(LA9_0>='a' && LA9_0<='z')||(LA9_0>='\u00C0' && LA9_0<='\u00D6')||(LA9_0>='\u00D8' && LA9_0<='\u00F6')||(LA9_0>='\u00F8' && LA9_0<='\u1FFF')||(LA9_0>='\u3040' && LA9_0<='\u318F')||(LA9_0>='\u3300' && LA9_0<='\u337F')||(LA9_0>='\u3400' && LA9_0<='\u3D2D')||(LA9_0>='\u4E00' && LA9_0<='\u9FFF')||(LA9_0>='\uF900' && LA9_0<='\uFAFF')) ) {
                alt9=1;
            }
            else if ( (LA9_0=='`') ) {
                alt9=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }
            switch (alt9) {
                case 1 :
                    // ExprGrammar.g:244:8: ( Letter ( Letter | JavaIDDigit | '/' )* )
                    {
                    // ExprGrammar.g:244:8: ( Letter ( Letter | JavaIDDigit | '/' )* )
                    // ExprGrammar.g:244:9: Letter ( Letter | JavaIDDigit | '/' )*
                    {
                    mLetter(); 
                    // ExprGrammar.g:244:16: ( Letter | JavaIDDigit | '/' )*
                    loop7:
                    do {
                        int alt7=2;
                        int LA7_0 = input.LA(1);

                        if ( (LA7_0=='$'||(LA7_0>='/' && LA7_0<='9')||(LA7_0>='A' && LA7_0<='Z')||LA7_0=='_'||(LA7_0>='a' && LA7_0<='z')||(LA7_0>='\u00C0' && LA7_0<='\u00D6')||(LA7_0>='\u00D8' && LA7_0<='\u00F6')||(LA7_0>='\u00F8' && LA7_0<='\u1FFF')||(LA7_0>='\u3040' && LA7_0<='\u318F')||(LA7_0>='\u3300' && LA7_0<='\u337F')||(LA7_0>='\u3400' && LA7_0<='\u3D2D')||(LA7_0>='\u4E00' && LA7_0<='\u9FFF')||(LA7_0>='\uF900' && LA7_0<='\uFAFF')) ) {
                            alt7=1;
                        }


                        switch (alt7) {
                    	case 1 :
                    	    // ExprGrammar.g:
                    	    {
                    	    if ( input.LA(1)=='$'||(input.LA(1)>='/' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z')||(input.LA(1)>='\u00C0' && input.LA(1)<='\u00D6')||(input.LA(1)>='\u00D8' && input.LA(1)<='\u00F6')||(input.LA(1)>='\u00F8' && input.LA(1)<='\u1FFF')||(input.LA(1)>='\u3040' && input.LA(1)<='\u318F')||(input.LA(1)>='\u3300' && input.LA(1)<='\u337F')||(input.LA(1)>='\u3400' && input.LA(1)<='\u3D2D')||(input.LA(1)>='\u4E00' && input.LA(1)<='\u9FFF')||(input.LA(1)>='\uF900' && input.LA(1)<='\uFAFF') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;

                    	default :
                    	    break loop7;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:244:45: ( '`' ( . )* '`' )
                    {
                    // ExprGrammar.g:244:45: ( '`' ( . )* '`' )
                    // ExprGrammar.g:244:47: '`' ( . )* '`'
                    {
                    match('`'); 
                    // ExprGrammar.g:244:51: ( . )*
                    loop8:
                    do {
                        int alt8=2;
                        int LA8_0 = input.LA(1);

                        if ( (LA8_0=='`') ) {
                            alt8=2;
                        }
                        else if ( ((LA8_0>='\u0000' && LA8_0<='_')||(LA8_0>='a' && LA8_0<='\uFFFF')) ) {
                            alt8=1;
                        }


                        switch (alt8) {
                    	case 1 :
                    	    // ExprGrammar.g:244:51: .
                    	    {
                    	    matchAny(); 

                    	    }
                    	    break;

                    	default :
                    	    break loop8;
                        }
                    } while (true);

                    match('`'); 

                    }


                    }
                    break;

            }

             
                        // strip backquotes if exists
                        String text = getText();
                        if (text.length() > 2 && text.charAt(0) == '`')
                            text = text.substring(1, text.length()-1);
                        /* change _type from ID to the type of the list the token belongs to */
            			/* allows to have case insentitive keywords */
                        if (isDataColumName(text)) _type = DATACOLUMNNAME;
                        else if (isOMColumName(text)) _type = OMCOLUMNNAME;
                        else if (Function.isFunction_n_to_n(getText())) _type = FUNCTION_N_TO_N; 
                        else if (Function.isFunction_n1or2_to_n(getText())) _type = FUNCTION_N1OR2_TO_N; 
                        else if (Function.isFunction_g_to_n(getText())) _type = FUNCTION_G_TO_N; 
                        else if (Function.isFunction_g_g_to_n(getText())) _type = FUNCTION_G_G_TO_N; 
                        else if (Function.isFunction_n_n_to_g(getText())) _type = FUNCTION_N_N_TO_G; 
                        else if (Function.isFunction_g_to_g(getText())) _type = FUNCTION_G_TO_G; 
                        else if (Function.isFunction_g_n_to_g(getText())) _type = FUNCTION_G_N_TO_G; 
                        else if (Function.isFunction_g_n_n_to_g(getText())) _type = FUNCTION_G_N_N_TO_G; 
                        else if (Function.isFunction_g_g_to_g(getText())) _type = FUNCTION_G_G_TO_G; 
                        else if (Function.isFunction_s_to_n(getText())) _type = FUNCTION_S_TO_N; 
                        else if (Function.isFunction_s_to_s(getText())) _type = FUNCTION_S_TO_S; 
                        else if (Function.isFunction_s_splus_to_s(getText())) _type = FUNCTION_S_SPLUS_TO_S; 
                        else if (Function.isFunction_n_splus_to_s(getText())) _type = FUNCTION_N_SPLUS_TO_S; 
                        else if (Function.isFunction_s_n1or2_to_s(getText())) _type = FUNCTION_S_N1OR2_TO_S; 
                        else if (Function.isFunction_s_s_to_n(getText())) _type = FUNCTION_S_S_TO_N; 
                        else if (Function.isFunction_Classif(getText())) _type = FUNCTION_CLASSIF;
                        else if (Function.isFunction_Classif_No_Class_Number(getText())) _type = FUNCTION_CLASSIF_NO_CLASS_NUMBER;
                        else if (Function.isFunction_Classif_Custom(getText())) _type = FUNCTION_CLASSIF_CUSTOM;
                        System.out.println("******** ID : >"+ getText() + "< -> type " + _type);
                    

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ID"

    // $ANTLR start "INT"
    public final void mINT() throws RecognitionException {
        try {
            int _type = INT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:276:5: ( ( '0' .. '9' )+ )
            // ExprGrammar.g:276:7: ( '0' .. '9' )+
            {
            // ExprGrammar.g:276:7: ( '0' .. '9' )+
            int cnt10=0;
            loop10:
            do {
                int alt10=2;
                int LA10_0 = input.LA(1);

                if ( ((LA10_0>='0' && LA10_0<='9')) ) {
                    alt10=1;
                }


                switch (alt10) {
            	case 1 :
            	    // ExprGrammar.g:276:7: '0' .. '9'
            	    {
            	    matchRange('0','9'); 

            	    }
            	    break;

            	default :
            	    if ( cnt10 >= 1 ) break loop10;
                        EarlyExitException eee =
                            new EarlyExitException(10, input);
                        throw eee;
                }
                cnt10++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "INT"

    // $ANTLR start "FLOAT"
    public final void mFLOAT() throws RecognitionException {
        try {
            int _type = FLOAT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:280:5: ( ( '0' .. '9' )+ '.' ( '0' .. '9' )* ( EXPONENT )? | '.' ( '0' .. '9' )+ ( EXPONENT )? | ( '0' .. '9' )+ EXPONENT )
            int alt17=3;
            alt17 = dfa17.predict(input);
            switch (alt17) {
                case 1 :
                    // ExprGrammar.g:280:9: ( '0' .. '9' )+ '.' ( '0' .. '9' )* ( EXPONENT )?
                    {
                    // ExprGrammar.g:280:9: ( '0' .. '9' )+
                    int cnt11=0;
                    loop11:
                    do {
                        int alt11=2;
                        int LA11_0 = input.LA(1);

                        if ( ((LA11_0>='0' && LA11_0<='9')) ) {
                            alt11=1;
                        }


                        switch (alt11) {
                    	case 1 :
                    	    // ExprGrammar.g:280:10: '0' .. '9'
                    	    {
                    	    matchRange('0','9'); 

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt11 >= 1 ) break loop11;
                                EarlyExitException eee =
                                    new EarlyExitException(11, input);
                                throw eee;
                        }
                        cnt11++;
                    } while (true);

                    match('.'); 
                    // ExprGrammar.g:280:25: ( '0' .. '9' )*
                    loop12:
                    do {
                        int alt12=2;
                        int LA12_0 = input.LA(1);

                        if ( ((LA12_0>='0' && LA12_0<='9')) ) {
                            alt12=1;
                        }


                        switch (alt12) {
                    	case 1 :
                    	    // ExprGrammar.g:280:26: '0' .. '9'
                    	    {
                    	    matchRange('0','9'); 

                    	    }
                    	    break;

                    	default :
                    	    break loop12;
                        }
                    } while (true);

                    // ExprGrammar.g:280:37: ( EXPONENT )?
                    int alt13=2;
                    int LA13_0 = input.LA(1);

                    if ( (LA13_0=='E'||LA13_0=='e') ) {
                        alt13=1;
                    }
                    switch (alt13) {
                        case 1 :
                            // ExprGrammar.g:280:37: EXPONENT
                            {
                            mEXPONENT(); 

                            }
                            break;

                    }


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:281:9: '.' ( '0' .. '9' )+ ( EXPONENT )?
                    {
                    match('.'); 
                    // ExprGrammar.g:281:13: ( '0' .. '9' )+
                    int cnt14=0;
                    loop14:
                    do {
                        int alt14=2;
                        int LA14_0 = input.LA(1);

                        if ( ((LA14_0>='0' && LA14_0<='9')) ) {
                            alt14=1;
                        }


                        switch (alt14) {
                    	case 1 :
                    	    // ExprGrammar.g:281:14: '0' .. '9'
                    	    {
                    	    matchRange('0','9'); 

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt14 >= 1 ) break loop14;
                                EarlyExitException eee =
                                    new EarlyExitException(14, input);
                                throw eee;
                        }
                        cnt14++;
                    } while (true);

                    // ExprGrammar.g:281:25: ( EXPONENT )?
                    int alt15=2;
                    int LA15_0 = input.LA(1);

                    if ( (LA15_0=='E'||LA15_0=='e') ) {
                        alt15=1;
                    }
                    switch (alt15) {
                        case 1 :
                            // ExprGrammar.g:281:25: EXPONENT
                            {
                            mEXPONENT(); 

                            }
                            break;

                    }


                    }
                    break;
                case 3 :
                    // ExprGrammar.g:282:9: ( '0' .. '9' )+ EXPONENT
                    {
                    // ExprGrammar.g:282:9: ( '0' .. '9' )+
                    int cnt16=0;
                    loop16:
                    do {
                        int alt16=2;
                        int LA16_0 = input.LA(1);

                        if ( ((LA16_0>='0' && LA16_0<='9')) ) {
                            alt16=1;
                        }


                        switch (alt16) {
                    	case 1 :
                    	    // ExprGrammar.g:282:10: '0' .. '9'
                    	    {
                    	    matchRange('0','9'); 

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt16 >= 1 ) break loop16;
                                EarlyExitException eee =
                                    new EarlyExitException(16, input);
                                throw eee;
                        }
                        cnt16++;
                    } while (true);

                    mEXPONENT(); 

                    }
                    break;

            }
            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FLOAT"

    // $ANTLR start "COMMENT"
    public final void mCOMMENT() throws RecognitionException {
        try {
            int _type = COMMENT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:286:5: ( '/*' ( options {greedy=false; } : . )* '*/' )
            // ExprGrammar.g:286:9: '/*' ( options {greedy=false; } : . )* '*/'
            {
            match("/*"); 

            // ExprGrammar.g:286:14: ( options {greedy=false; } : . )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0=='*') ) {
                    int LA18_1 = input.LA(2);

                    if ( (LA18_1=='/') ) {
                        alt18=2;
                    }
                    else if ( ((LA18_1>='\u0000' && LA18_1<='.')||(LA18_1>='0' && LA18_1<='\uFFFF')) ) {
                        alt18=1;
                    }


                }
                else if ( ((LA18_0>='\u0000' && LA18_0<=')')||(LA18_0>='+' && LA18_0<='\uFFFF')) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // ExprGrammar.g:286:42: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);

            match("*/"); 

            _channel=HIDDEN;

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "COMMENT"

    // $ANTLR start "WS"
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:289:5: ( ( ' ' | '\\t' | '\\r' | '\\n' ) )
            // ExprGrammar.g:289:9: ( ' ' | '\\t' | '\\r' | '\\n' )
            {
            if ( (input.LA(1)>='\t' && input.LA(1)<='\n')||input.LA(1)=='\r'||input.LA(1)==' ' ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}

            _channel=HIDDEN;

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "WS"

    // $ANTLR start "STRING"
    public final void mSTRING() throws RecognitionException {
        try {
            int _type = STRING;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // ExprGrammar.g:297:5: ( '\"' ( ESC_SEQ | ~ ( '\\\\' | '\"' ) )* '\"' )
            // ExprGrammar.g:297:8: '\"' ( ESC_SEQ | ~ ( '\\\\' | '\"' ) )* '\"'
            {
            match('\"'); 
            // ExprGrammar.g:297:12: ( ESC_SEQ | ~ ( '\\\\' | '\"' ) )*
            loop19:
            do {
                int alt19=3;
                int LA19_0 = input.LA(1);

                if ( (LA19_0=='\\') ) {
                    alt19=1;
                }
                else if ( ((LA19_0>='\u0000' && LA19_0<='!')||(LA19_0>='#' && LA19_0<='[')||(LA19_0>=']' && LA19_0<='\uFFFF')) ) {
                    alt19=2;
                }


                switch (alt19) {
            	case 1 :
            	    // ExprGrammar.g:297:14: ESC_SEQ
            	    {
            	    mESC_SEQ(); 

            	    }
            	    break;
            	case 2 :
            	    // ExprGrammar.g:297:24: ~ ( '\\\\' | '\"' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='!')||(input.LA(1)>='#' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);

            match('\"'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "STRING"

    // $ANTLR start "EXPONENT"
    public final void mEXPONENT() throws RecognitionException {
        try {
            // ExprGrammar.g:301:10: ( ( 'e' | 'E' ) ( '+' | '-' )? ( '0' .. '9' )+ )
            // ExprGrammar.g:301:12: ( 'e' | 'E' ) ( '+' | '-' )? ( '0' .. '9' )+
            {
            if ( input.LA(1)=='E'||input.LA(1)=='e' ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}

            // ExprGrammar.g:301:22: ( '+' | '-' )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0=='+'||LA20_0=='-') ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // ExprGrammar.g:
                    {
                    if ( input.LA(1)=='+'||input.LA(1)=='-' ) {
                        input.consume();

                    }
                    else {
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        recover(mse);
                        throw mse;}


                    }
                    break;

            }

            // ExprGrammar.g:301:33: ( '0' .. '9' )+
            int cnt21=0;
            loop21:
            do {
                int alt21=2;
                int LA21_0 = input.LA(1);

                if ( ((LA21_0>='0' && LA21_0<='9')) ) {
                    alt21=1;
                }


                switch (alt21) {
            	case 1 :
            	    // ExprGrammar.g:301:34: '0' .. '9'
            	    {
            	    matchRange('0','9'); 

            	    }
            	    break;

            	default :
            	    if ( cnt21 >= 1 ) break loop21;
                        EarlyExitException eee =
                            new EarlyExitException(21, input);
                        throw eee;
                }
                cnt21++;
            } while (true);


            }

        }
        finally {
        }
    }
    // $ANTLR end "EXPONENT"

    // $ANTLR start "HEX_DIGIT"
    public final void mHEX_DIGIT() throws RecognitionException {
        try {
            // ExprGrammar.g:304:11: ( ( '0' .. '9' | 'a' .. 'f' | 'A' .. 'F' ) )
            // ExprGrammar.g:304:13: ( '0' .. '9' | 'a' .. 'f' | 'A' .. 'F' )
            {
            if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='F')||(input.LA(1)>='a' && input.LA(1)<='f') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}


            }

        }
        finally {
        }
    }
    // $ANTLR end "HEX_DIGIT"

    // $ANTLR start "ESC_SEQ"
    public final void mESC_SEQ() throws RecognitionException {
        try {
            // ExprGrammar.g:308:5: ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' ) | UNICODE_ESC | OCTAL_ESC )
            int alt22=3;
            int LA22_0 = input.LA(1);

            if ( (LA22_0=='\\') ) {
                switch ( input.LA(2) ) {
                case '\"':
                case '\'':
                case '\\':
                case 'b':
                case 'f':
                case 'n':
                case 'r':
                case 't':
                    {
                    alt22=1;
                    }
                    break;
                case 'u':
                    {
                    alt22=2;
                    }
                    break;
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                    {
                    alt22=3;
                    }
                    break;
                default:
                    NoViableAltException nvae =
                        new NoViableAltException("", 22, 1, input);

                    throw nvae;
                }

            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 22, 0, input);

                throw nvae;
            }
            switch (alt22) {
                case 1 :
                    // ExprGrammar.g:308:9: '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' )
                    {
                    match('\\'); 
                    if ( input.LA(1)=='\"'||input.LA(1)=='\''||input.LA(1)=='\\'||input.LA(1)=='b'||input.LA(1)=='f'||input.LA(1)=='n'||input.LA(1)=='r'||input.LA(1)=='t' ) {
                        input.consume();

                    }
                    else {
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        recover(mse);
                        throw mse;}


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:309:9: UNICODE_ESC
                    {
                    mUNICODE_ESC(); 

                    }
                    break;
                case 3 :
                    // ExprGrammar.g:310:9: OCTAL_ESC
                    {
                    mOCTAL_ESC(); 

                    }
                    break;

            }
        }
        finally {
        }
    }
    // $ANTLR end "ESC_SEQ"

    // $ANTLR start "OCTAL_ESC"
    public final void mOCTAL_ESC() throws RecognitionException {
        try {
            // ExprGrammar.g:315:5: ( '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) )
            int alt23=3;
            int LA23_0 = input.LA(1);

            if ( (LA23_0=='\\') ) {
                int LA23_1 = input.LA(2);

                if ( ((LA23_1>='0' && LA23_1<='3')) ) {
                    int LA23_2 = input.LA(3);

                    if ( ((LA23_2>='0' && LA23_2<='7')) ) {
                        int LA23_4 = input.LA(4);

                        if ( ((LA23_4>='0' && LA23_4<='7')) ) {
                            alt23=1;
                        }
                        else {
                            alt23=2;}
                    }
                    else {
                        alt23=3;}
                }
                else if ( ((LA23_1>='4' && LA23_1<='7')) ) {
                    int LA23_3 = input.LA(3);

                    if ( ((LA23_3>='0' && LA23_3<='7')) ) {
                        alt23=2;
                    }
                    else {
                        alt23=3;}
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 23, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;
            }
            switch (alt23) {
                case 1 :
                    // ExprGrammar.g:315:9: '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' )
                    {
                    match('\\'); 
                    // ExprGrammar.g:315:14: ( '0' .. '3' )
                    // ExprGrammar.g:315:15: '0' .. '3'
                    {
                    matchRange('0','3'); 

                    }

                    // ExprGrammar.g:315:25: ( '0' .. '7' )
                    // ExprGrammar.g:315:26: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }

                    // ExprGrammar.g:315:36: ( '0' .. '7' )
                    // ExprGrammar.g:315:37: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;
                case 2 :
                    // ExprGrammar.g:316:9: '\\\\' ( '0' .. '7' ) ( '0' .. '7' )
                    {
                    match('\\'); 
                    // ExprGrammar.g:316:14: ( '0' .. '7' )
                    // ExprGrammar.g:316:15: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }

                    // ExprGrammar.g:316:25: ( '0' .. '7' )
                    // ExprGrammar.g:316:26: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;
                case 3 :
                    // ExprGrammar.g:317:9: '\\\\' ( '0' .. '7' )
                    {
                    match('\\'); 
                    // ExprGrammar.g:317:14: ( '0' .. '7' )
                    // ExprGrammar.g:317:15: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;

            }
        }
        finally {
        }
    }
    // $ANTLR end "OCTAL_ESC"

    // $ANTLR start "UNICODE_ESC"
    public final void mUNICODE_ESC() throws RecognitionException {
        try {
            // ExprGrammar.g:322:5: ( '\\\\' 'u' HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT )
            // ExprGrammar.g:322:9: '\\\\' 'u' HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT
            {
            match('\\'); 
            match('u'); 
            mHEX_DIGIT(); 
            mHEX_DIGIT(); 
            mHEX_DIGIT(); 
            mHEX_DIGIT(); 

            }

        }
        finally {
        }
    }
    // $ANTLR end "UNICODE_ESC"

    // $ANTLR start "Letter"
    public final void mLetter() throws RecognitionException {
        try {
            // ExprGrammar.g:327:5: ( '\\u0024' | '\\u0041' .. '\\u005a' | '\\u005f' | '\\u0061' .. '\\u007a' | '\\u00c0' .. '\\u00d6' | '\\u00d8' .. '\\u00f6' | '\\u00f8' .. '\\u00ff' | '\\u0100' .. '\\u1fff' | '\\u3040' .. '\\u318f' | '\\u3300' .. '\\u337f' | '\\u3400' .. '\\u3d2d' | '\\u4e00' .. '\\u9fff' | '\\uf900' .. '\\ufaff' )
            // ExprGrammar.g:
            {
            if ( input.LA(1)=='$'||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z')||(input.LA(1)>='\u00C0' && input.LA(1)<='\u00D6')||(input.LA(1)>='\u00D8' && input.LA(1)<='\u00F6')||(input.LA(1)>='\u00F8' && input.LA(1)<='\u1FFF')||(input.LA(1)>='\u3040' && input.LA(1)<='\u318F')||(input.LA(1)>='\u3300' && input.LA(1)<='\u337F')||(input.LA(1)>='\u3400' && input.LA(1)<='\u3D2D')||(input.LA(1)>='\u4E00' && input.LA(1)<='\u9FFF')||(input.LA(1)>='\uF900' && input.LA(1)<='\uFAFF') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}


            }

        }
        finally {
        }
    }
    // $ANTLR end "Letter"

    // $ANTLR start "JavaIDDigit"
    public final void mJavaIDDigit() throws RecognitionException {
        try {
            // ExprGrammar.g:344:5: ( '\\u0030' .. '\\u0039' | '\\u0660' .. '\\u0669' | '\\u06f0' .. '\\u06f9' | '\\u0966' .. '\\u096f' | '\\u09e6' .. '\\u09ef' | '\\u0a66' .. '\\u0a6f' | '\\u0ae6' .. '\\u0aef' | '\\u0b66' .. '\\u0b6f' | '\\u0be7' .. '\\u0bef' | '\\u0c66' .. '\\u0c6f' | '\\u0ce6' .. '\\u0cef' | '\\u0d66' .. '\\u0d6f' | '\\u0e50' .. '\\u0e59' | '\\u0ed0' .. '\\u0ed9' | '\\u1040' .. '\\u1049' )
            // ExprGrammar.g:
            {
            if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='\u0660' && input.LA(1)<='\u0669')||(input.LA(1)>='\u06F0' && input.LA(1)<='\u06F9')||(input.LA(1)>='\u0966' && input.LA(1)<='\u096F')||(input.LA(1)>='\u09E6' && input.LA(1)<='\u09EF')||(input.LA(1)>='\u0A66' && input.LA(1)<='\u0A6F')||(input.LA(1)>='\u0AE6' && input.LA(1)<='\u0AEF')||(input.LA(1)>='\u0B66' && input.LA(1)<='\u0B6F')||(input.LA(1)>='\u0BE7' && input.LA(1)<='\u0BEF')||(input.LA(1)>='\u0C66' && input.LA(1)<='\u0C6F')||(input.LA(1)>='\u0CE6' && input.LA(1)<='\u0CEF')||(input.LA(1)>='\u0D66' && input.LA(1)<='\u0D6F')||(input.LA(1)>='\u0E50' && input.LA(1)<='\u0E59')||(input.LA(1)>='\u0ED0' && input.LA(1)<='\u0ED9')||(input.LA(1)>='\u1040' && input.LA(1)<='\u1049') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}


            }

        }
        finally {
        }
    }
    // $ANTLR end "JavaIDDigit"

    public void mTokens() throws RecognitionException {
        // ExprGrammar.g:1:8: ( LBRACE | RBRACE | LPAREN | RPAREN | DOT | SEMIC | COMMA | LT | GT | LTE | GTE | EQ | NEQ | NOTEQ | ADD | SUB | MUL | MOD | AND | OR | XOR | INV | DIV | TRUE | FALSE | FUNCTION_N_TO_N | FUNCTION_N1OR2_TO_N | FUNCTION_G_TO_N | FUNCTION_G_G_TO_N | FUNCTION_N_N_TO_G | FUNCTION_G_TO_G | FUNCTION_G_N_TO_G | FUNCTION_G_N_N_TO_G | FUNCTION_G_G_TO_G | FUNCTION_S_TO_N | FUNCTION_S_TO_S | FUNCTION_S_SPLUS_TO_S | FUNCTION_N_SPLUS_TO_S | FUNCTION_S_N1OR2_TO_S | FUNCTION_S_S_TO_N | FUNCTION_CLASSIF_NO_CLASS_NUMBER | FUNCTION_CLASSIF | FUNCTION_CLASSIF_CUSTOM | OMCOLUMNNAME | DATACOLUMNNAME | IF | NOT | LAND | LOR | ID | INT | FLOAT | COMMENT | WS | STRING )
        int alt24=55;
        alt24 = dfa24.predict(input);
        switch (alt24) {
            case 1 :
                // ExprGrammar.g:1:10: LBRACE
                {
                mLBRACE(); 

                }
                break;
            case 2 :
                // ExprGrammar.g:1:17: RBRACE
                {
                mRBRACE(); 

                }
                break;
            case 3 :
                // ExprGrammar.g:1:24: LPAREN
                {
                mLPAREN(); 

                }
                break;
            case 4 :
                // ExprGrammar.g:1:31: RPAREN
                {
                mRPAREN(); 

                }
                break;
            case 5 :
                // ExprGrammar.g:1:38: DOT
                {
                mDOT(); 

                }
                break;
            case 6 :
                // ExprGrammar.g:1:42: SEMIC
                {
                mSEMIC(); 

                }
                break;
            case 7 :
                // ExprGrammar.g:1:48: COMMA
                {
                mCOMMA(); 

                }
                break;
            case 8 :
                // ExprGrammar.g:1:54: LT
                {
                mLT(); 

                }
                break;
            case 9 :
                // ExprGrammar.g:1:57: GT
                {
                mGT(); 

                }
                break;
            case 10 :
                // ExprGrammar.g:1:60: LTE
                {
                mLTE(); 

                }
                break;
            case 11 :
                // ExprGrammar.g:1:64: GTE
                {
                mGTE(); 

                }
                break;
            case 12 :
                // ExprGrammar.g:1:68: EQ
                {
                mEQ(); 

                }
                break;
            case 13 :
                // ExprGrammar.g:1:71: NEQ
                {
                mNEQ(); 

                }
                break;
            case 14 :
                // ExprGrammar.g:1:75: NOTEQ
                {
                mNOTEQ(); 

                }
                break;
            case 15 :
                // ExprGrammar.g:1:81: ADD
                {
                mADD(); 

                }
                break;
            case 16 :
                // ExprGrammar.g:1:85: SUB
                {
                mSUB(); 

                }
                break;
            case 17 :
                // ExprGrammar.g:1:89: MUL
                {
                mMUL(); 

                }
                break;
            case 18 :
                // ExprGrammar.g:1:93: MOD
                {
                mMOD(); 

                }
                break;
            case 19 :
                // ExprGrammar.g:1:97: AND
                {
                mAND(); 

                }
                break;
            case 20 :
                // ExprGrammar.g:1:101: OR
                {
                mOR(); 

                }
                break;
            case 21 :
                // ExprGrammar.g:1:104: XOR
                {
                mXOR(); 

                }
                break;
            case 22 :
                // ExprGrammar.g:1:108: INV
                {
                mINV(); 

                }
                break;
            case 23 :
                // ExprGrammar.g:1:112: DIV
                {
                mDIV(); 

                }
                break;
            case 24 :
                // ExprGrammar.g:1:116: TRUE
                {
                mTRUE(); 

                }
                break;
            case 25 :
                // ExprGrammar.g:1:121: FALSE
                {
                mFALSE(); 

                }
                break;
            case 26 :
                // ExprGrammar.g:1:127: FUNCTION_N_TO_N
                {
                mFUNCTION_N_TO_N(); 

                }
                break;
            case 27 :
                // ExprGrammar.g:1:143: FUNCTION_N1OR2_TO_N
                {
                mFUNCTION_N1OR2_TO_N(); 

                }
                break;
            case 28 :
                // ExprGrammar.g:1:163: FUNCTION_G_TO_N
                {
                mFUNCTION_G_TO_N(); 

                }
                break;
            case 29 :
                // ExprGrammar.g:1:179: FUNCTION_G_G_TO_N
                {
                mFUNCTION_G_G_TO_N(); 

                }
                break;
            case 30 :
                // ExprGrammar.g:1:197: FUNCTION_N_N_TO_G
                {
                mFUNCTION_N_N_TO_G(); 

                }
                break;
            case 31 :
                // ExprGrammar.g:1:215: FUNCTION_G_TO_G
                {
                mFUNCTION_G_TO_G(); 

                }
                break;
            case 32 :
                // ExprGrammar.g:1:231: FUNCTION_G_N_TO_G
                {
                mFUNCTION_G_N_TO_G(); 

                }
                break;
            case 33 :
                // ExprGrammar.g:1:249: FUNCTION_G_N_N_TO_G
                {
                mFUNCTION_G_N_N_TO_G(); 

                }
                break;
            case 34 :
                // ExprGrammar.g:1:269: FUNCTION_G_G_TO_G
                {
                mFUNCTION_G_G_TO_G(); 

                }
                break;
            case 35 :
                // ExprGrammar.g:1:287: FUNCTION_S_TO_N
                {
                mFUNCTION_S_TO_N(); 

                }
                break;
            case 36 :
                // ExprGrammar.g:1:303: FUNCTION_S_TO_S
                {
                mFUNCTION_S_TO_S(); 

                }
                break;
            case 37 :
                // ExprGrammar.g:1:319: FUNCTION_S_SPLUS_TO_S
                {
                mFUNCTION_S_SPLUS_TO_S(); 

                }
                break;
            case 38 :
                // ExprGrammar.g:1:341: FUNCTION_N_SPLUS_TO_S
                {
                mFUNCTION_N_SPLUS_TO_S(); 

                }
                break;
            case 39 :
                // ExprGrammar.g:1:363: FUNCTION_S_N1OR2_TO_S
                {
                mFUNCTION_S_N1OR2_TO_S(); 

                }
                break;
            case 40 :
                // ExprGrammar.g:1:385: FUNCTION_S_S_TO_N
                {
                mFUNCTION_S_S_TO_N(); 

                }
                break;
            case 41 :
                // ExprGrammar.g:1:403: FUNCTION_CLASSIF_NO_CLASS_NUMBER
                {
                mFUNCTION_CLASSIF_NO_CLASS_NUMBER(); 

                }
                break;
            case 42 :
                // ExprGrammar.g:1:436: FUNCTION_CLASSIF
                {
                mFUNCTION_CLASSIF(); 

                }
                break;
            case 43 :
                // ExprGrammar.g:1:453: FUNCTION_CLASSIF_CUSTOM
                {
                mFUNCTION_CLASSIF_CUSTOM(); 

                }
                break;
            case 44 :
                // ExprGrammar.g:1:477: OMCOLUMNNAME
                {
                mOMCOLUMNNAME(); 

                }
                break;
            case 45 :
                // ExprGrammar.g:1:490: DATACOLUMNNAME
                {
                mDATACOLUMNNAME(); 

                }
                break;
            case 46 :
                // ExprGrammar.g:1:505: IF
                {
                mIF(); 

                }
                break;
            case 47 :
                // ExprGrammar.g:1:508: NOT
                {
                mNOT(); 

                }
                break;
            case 48 :
                // ExprGrammar.g:1:512: LAND
                {
                mLAND(); 

                }
                break;
            case 49 :
                // ExprGrammar.g:1:517: LOR
                {
                mLOR(); 

                }
                break;
            case 50 :
                // ExprGrammar.g:1:521: ID
                {
                mID(); 

                }
                break;
            case 51 :
                // ExprGrammar.g:1:524: INT
                {
                mINT(); 

                }
                break;
            case 52 :
                // ExprGrammar.g:1:528: FLOAT
                {
                mFLOAT(); 

                }
                break;
            case 53 :
                // ExprGrammar.g:1:534: COMMENT
                {
                mCOMMENT(); 

                }
                break;
            case 54 :
                // ExprGrammar.g:1:542: WS
                {
                mWS(); 

                }
                break;
            case 55 :
                // ExprGrammar.g:1:545: STRING
                {
                mSTRING(); 

                }
                break;

        }

    }


    protected DFA17 dfa17 = new DFA17(this);
    protected DFA24 dfa24 = new DFA24(this);
    static final String DFA17_eotS =
        "\5\uffff";
    static final String DFA17_eofS =
        "\5\uffff";
    static final String DFA17_minS =
        "\2\56\3\uffff";
    static final String DFA17_maxS =
        "\1\71\1\145\3\uffff";
    static final String DFA17_acceptS =
        "\2\uffff\1\2\1\1\1\3";
    static final String DFA17_specialS =
        "\5\uffff}>";
    static final String[] DFA17_transitionS = {
            "\1\2\1\uffff\12\1",
            "\1\3\1\uffff\12\1\13\uffff\1\4\37\uffff\1\4",
            "",
            "",
            ""
    };

    static final short[] DFA17_eot = DFA.unpackEncodedString(DFA17_eotS);
    static final short[] DFA17_eof = DFA.unpackEncodedString(DFA17_eofS);
    static final char[] DFA17_min = DFA.unpackEncodedStringToUnsignedChars(DFA17_minS);
    static final char[] DFA17_max = DFA.unpackEncodedStringToUnsignedChars(DFA17_maxS);
    static final short[] DFA17_accept = DFA.unpackEncodedString(DFA17_acceptS);
    static final short[] DFA17_special = DFA.unpackEncodedString(DFA17_specialS);
    static final short[][] DFA17_transition;

    static {
        int numStates = DFA17_transitionS.length;
        DFA17_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA17_transition[i] = DFA.unpackEncodedString(DFA17_transitionS[i]);
        }
    }

    class DFA17 extends DFA {

        public DFA17(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 17;
            this.eot = DFA17_eot;
            this.eof = DFA17_eof;
            this.min = DFA17_min;
            this.max = DFA17_max;
            this.accept = DFA17_accept;
            this.special = DFA17_special;
            this.transition = DFA17_transition;
        }
        public String getDescription() {
            return "279:1: FLOAT : ( ( '0' .. '9' )+ '.' ( '0' .. '9' )* ( EXPONENT )? | '.' ( '0' .. '9' )+ ( EXPONENT )? | ( '0' .. '9' )+ EXPONENT );";
        }
    }
    static final String DFA24_eotS =
        "\5\uffff\1\53\2\uffff\1\57\1\61\1\uffff\1\63\4\uffff\1\65\1\67\2"+
        "\uffff\1\71\22\47\1\uffff\1\121\21\uffff\17\47\2\144\4\47\2\66\1"+
        "\uffff\5\47\1\156\14\47\1\uffff\2\63\2\64\1\176\1\177\1\176\2\47"+
        "\1\uffff\16\47\1\u0092\2\uffff\2\u0093\6\47\1\u009a\3\47\1\u009e"+
        "\3\47\1\u00a2\1\47\2\uffff\1\u00a4\1\47\1\u00a6\3\47\1\uffff\3\47"+
        "\1\uffff\3\47\1\uffff\1\u00b0\1\uffff\1\47\1\uffff\3\47\1\u00b5"+
        "\5\47\1\uffff\1\u00bc\3\47\1\uffff\1\u00c0\2\47\1\u00c3\1\u00c4"+
        "\1\47\1\uffff\2\47\1\u00c8\1\uffff\1\u00c9\1\u00ca\2\uffff\3\47"+
        "\3\uffff\1\47\1\u00cf\1\u00d0\1\47\2\uffff\3\47\1\u00d5\1\uffff";
    static final String DFA24_eofS =
        "\u00d6\uffff";
    static final String DFA24_minS =
        "\1\11\4\uffff\1\60\2\uffff\2\75\1\uffff\1\75\4\uffff\1\46\1\174"+
        "\2\uffff\1\52\1\122\1\162\1\101\1\141\1\105\1\117\1\110\1\101\1"+
        "\105\1\101\1\146\1\106\1\157\1\117\1\156\1\116\1\162\1\122\1\uffff"+
        "\1\56\21\uffff\1\111\1\165\1\114\1\154\2\116\1\117\1\137\1\125\1"+
        "\137\1\102\1\101\1\113\1\116\1\124\2\44\1\164\1\124\1\144\1\104"+
        "\2\44\1\uffff\1\105\1\115\1\145\1\123\1\163\1\44\1\103\1\124\1\117"+
        "\1\103\1\116\1\101\1\123\1\120\1\105\1\103\1\107\1\101\1\uffff\7"+
        "\44\1\105\1\145\1\uffff\1\101\1\122\1\123\1\111\2\125\1\104\1\122"+
        "\1\116\1\124\1\105\1\104\1\110\1\124\1\44\2\uffff\2\44\1\124\1\117"+
        "\1\105\1\123\1\101\1\123\1\44\1\105\1\111\1\122\1\44\1\117\1\111"+
        "\1\105\1\44\1\110\2\uffff\1\44\1\111\1\44\1\103\1\116\1\124\1\uffff"+
        "\1\101\1\117\1\111\1\uffff\1\111\1\123\1\103\1\uffff\1\44\1\uffff"+
        "\1\104\1\uffff\1\122\1\124\1\117\1\44\3\116\1\103\1\124\1\uffff"+
        "\1\44\1\105\1\111\1\115\1\uffff\1\44\1\107\1\124\2\44\1\111\1\uffff"+
        "\1\124\1\114\1\44\1\uffff\2\44\2\uffff\1\123\2\105\3\uffff\1\124"+
        "\2\44\1\101\2\uffff\1\116\1\103\1\105\1\44\1\uffff";
    static final String DFA24_maxS =
        "\1\ufaff\4\uffff\1\71\2\uffff\1\76\1\75\1\uffff\1\75\4\uffff\1\46"+
        "\1\174\2\uffff\1\52\1\122\1\162\1\101\1\141\2\117\1\125\1\101\1"+
        "\105\1\101\1\146\1\106\1\157\1\117\1\156\1\116\1\162\1\122\1\uffff"+
        "\1\145\21\uffff\1\125\1\165\1\114\1\154\1\123\1\116\1\117\1\137"+
        "\1\125\1\137\1\102\1\101\1\124\1\116\1\124\2\ufaff\1\164\1\124\1"+
        "\144\1\104\2\ufaff\1\uffff\1\105\1\115\1\145\1\123\1\163\1\ufaff"+
        "\1\103\1\124\1\117\1\121\1\116\1\125\1\123\1\120\1\105\1\103\1\107"+
        "\1\101\1\uffff\7\ufaff\1\105\1\145\1\uffff\1\101\1\122\1\123\1\111"+
        "\2\125\1\104\1\122\1\116\1\124\1\105\1\122\1\110\1\124\1\ufaff\2"+
        "\uffff\2\ufaff\1\124\1\117\1\105\1\123\1\101\1\123\1\ufaff\1\105"+
        "\1\111\1\122\1\ufaff\1\117\1\111\1\105\1\ufaff\1\110\2\uffff\1\ufaff"+
        "\1\111\1\ufaff\1\103\1\116\1\124\1\uffff\1\101\1\117\1\111\1\uffff"+
        "\1\111\1\123\1\103\1\uffff\1\ufaff\1\uffff\1\104\1\uffff\1\122\1"+
        "\124\1\117\1\ufaff\3\116\1\103\1\124\1\uffff\1\ufaff\1\105\1\111"+
        "\1\115\1\uffff\1\ufaff\1\107\1\124\2\ufaff\1\111\1\uffff\1\124\1"+
        "\114\1\ufaff\1\uffff\2\ufaff\2\uffff\1\123\2\105\3\uffff\1\124\2"+
        "\ufaff\1\101\2\uffff\1\116\1\103\1\105\1\ufaff\1\uffff";
    static final String DFA24_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\uffff\1\6\1\7\2\uffff\1\14\1\uffff\1"+
        "\17\1\20\1\21\1\22\2\uffff\1\25\1\26\23\uffff\1\62\1\uffff\1\66"+
        "\1\67\1\5\1\64\1\12\1\15\1\10\1\13\1\11\1\16\1\57\1\60\1\23\1\61"+
        "\1\24\1\65\1\27\27\uffff\1\63\22\uffff\1\56\11\uffff\1\32\17\uffff"+
        "\1\30\1\44\22\uffff\1\55\1\31\6\uffff\1\33\3\uffff\1\54\3\uffff"+
        "\1\50\1\uffff\1\45\1\uffff\1\46\11\uffff\1\43\4\uffff\1\34\6\uffff"+
        "\1\37\3\uffff\1\42\2\uffff\1\40\1\41\3\uffff\1\53\1\47\1\36\4\uffff"+
        "\1\51\1\52\4\uffff\1\35";
    static final String DFA24_specialS =
        "\u00d6\uffff}>";
    static final String[] DFA24_transitionS = {
            "\2\51\2\uffff\1\51\22\uffff\1\51\1\13\1\52\1\uffff\1\47\1\17"+
            "\1\20\1\uffff\1\3\1\4\1\16\1\14\1\7\1\15\1\5\1\24\12\50\1\uffff"+
            "\1\6\1\10\1\12\1\11\2\uffff\1\44\1\47\1\31\1\36\1\47\1\27\2"+
            "\47\1\40\2\47\1\35\1\34\1\42\1\46\2\47\1\32\1\33\1\25\6\47\3"+
            "\uffff\1\22\2\47\1\43\4\47\1\30\2\47\1\37\4\47\1\41\1\45\4\47"+
            "\1\26\6\47\1\1\1\21\1\2\1\23\101\uffff\27\47\1\uffff\37\47\1"+
            "\uffff\u1f08\47\u1040\uffff\u0150\47\u0170\uffff\u0080\47\u0080"+
            "\uffff\u092e\47\u10d2\uffff\u5200\47\u5900\uffff\u0200\47",
            "",
            "",
            "",
            "",
            "\12\54",
            "",
            "",
            "\1\55\1\56",
            "\1\60",
            "",
            "\1\62",
            "",
            "",
            "",
            "",
            "\1\64",
            "\1\66",
            "",
            "",
            "\1\70",
            "\1\72",
            "\1\73",
            "\1\74",
            "\1\75",
            "\1\77\2\uffff\1\100\3\uffff\1\101\2\uffff\1\76",
            "\1\102",
            "\1\105\13\uffff\1\103\1\104",
            "\1\106",
            "\1\107",
            "\1\110",
            "\1\111",
            "\1\112",
            "\1\113",
            "\1\114",
            "\1\115",
            "\1\116",
            "\1\117",
            "\1\120",
            "",
            "\1\54\1\uffff\12\50\13\uffff\1\54\37\uffff\1\54",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\123\13\uffff\1\122",
            "\1\124",
            "\1\125",
            "\1\126",
            "\1\130\4\uffff\1\127",
            "\1\131",
            "\1\132",
            "\1\133",
            "\1\134",
            "\1\135",
            "\1\136",
            "\1\137",
            "\1\140\10\uffff\1\141",
            "\1\142",
            "\1\143",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\145",
            "\1\146",
            "\1\147",
            "\1\150",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "",
            "\1\151",
            "\1\152",
            "\1\153",
            "\1\154",
            "\1\155",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\157",
            "\1\160",
            "\1\161",
            "\1\164\1\162\14\uffff\1\163",
            "\1\165",
            "\1\166\23\uffff\1\167",
            "\1\170",
            "\1\171",
            "\1\172",
            "\1\173",
            "\1\174",
            "\1\175",
            "",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u0080",
            "\1\u0081",
            "",
            "\1\u0082",
            "\1\u0083",
            "\1\u0084",
            "\1\u0085",
            "\1\u0086",
            "\1\u0087",
            "\1\u0088",
            "\1\u0089",
            "\1\u008a",
            "\1\u008b",
            "\1\u008c",
            "\1\u008e\13\uffff\1\u008d\1\uffff\1\u008f",
            "\1\u0090",
            "\1\u0091",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "",
            "",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u0094",
            "\1\u0095",
            "\1\u0096",
            "\1\u0097",
            "\1\u0098",
            "\1\u0099",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u009b",
            "\1\u009c",
            "\1\u009d",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u009f",
            "\1\u00a0",
            "\1\u00a1",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u00a3",
            "",
            "",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u00a5",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u00a7",
            "\1\u00a8",
            "\1\u00a9",
            "",
            "\1\u00aa",
            "\1\u00ab",
            "\1\u00ac",
            "",
            "\1\u00ad",
            "\1\u00ae",
            "\1\u00af",
            "",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "",
            "\1\u00b1",
            "",
            "\1\u00b2",
            "\1\u00b3",
            "\1\u00b4",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u00b6",
            "\1\u00b7",
            "\1\u00b8",
            "\1\u00b9",
            "\1\u00ba",
            "",
            "\1\47\12\uffff\13\47\7\uffff\3\47\1\u00bb\26\47\4\uffff\1\47"+
            "\1\uffff\32\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47"+
            "\u1040\uffff\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e"+
            "\47\u10d2\uffff\u5200\47\u5900\uffff\u0200\47",
            "\1\u00bd",
            "\1\u00be",
            "\1\u00bf",
            "",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u00c1",
            "\1\u00c2",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u00c5",
            "",
            "\1\u00c6",
            "\1\u00c7",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "",
            "",
            "\1\u00cb",
            "\1\u00cc",
            "\1\u00cd",
            "",
            "",
            "",
            "\1\u00ce",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            "\1\u00d1",
            "",
            "",
            "\1\u00d2",
            "\1\u00d3",
            "\1\u00d4",
            "\1\47\12\uffff\13\47\7\uffff\32\47\4\uffff\1\47\1\uffff\32"+
            "\47\105\uffff\27\47\1\uffff\37\47\1\uffff\u1f08\47\u1040\uffff"+
            "\u0150\47\u0170\uffff\u0080\47\u0080\uffff\u092e\47\u10d2\uffff"+
            "\u5200\47\u5900\uffff\u0200\47",
            ""
    };

    static final short[] DFA24_eot = DFA.unpackEncodedString(DFA24_eotS);
    static final short[] DFA24_eof = DFA.unpackEncodedString(DFA24_eofS);
    static final char[] DFA24_min = DFA.unpackEncodedStringToUnsignedChars(DFA24_minS);
    static final char[] DFA24_max = DFA.unpackEncodedStringToUnsignedChars(DFA24_maxS);
    static final short[] DFA24_accept = DFA.unpackEncodedString(DFA24_acceptS);
    static final short[] DFA24_special = DFA.unpackEncodedString(DFA24_specialS);
    static final short[][] DFA24_transition;

    static {
        int numStates = DFA24_transitionS.length;
        DFA24_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA24_transition[i] = DFA.unpackEncodedString(DFA24_transitionS[i]);
        }
    }

    class DFA24 extends DFA {

        public DFA24(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 24;
            this.eot = DFA24_eot;
            this.eof = DFA24_eof;
            this.min = DFA24_min;
            this.max = DFA24_max;
            this.accept = DFA24_accept;
            this.special = DFA24_special;
            this.transition = DFA24_transition;
        }
        public String getDescription() {
            return "1:1: Tokens : ( LBRACE | RBRACE | LPAREN | RPAREN | DOT | SEMIC | COMMA | LT | GT | LTE | GTE | EQ | NEQ | NOTEQ | ADD | SUB | MUL | MOD | AND | OR | XOR | INV | DIV | TRUE | FALSE | FUNCTION_N_TO_N | FUNCTION_N1OR2_TO_N | FUNCTION_G_TO_N | FUNCTION_G_G_TO_N | FUNCTION_N_N_TO_G | FUNCTION_G_TO_G | FUNCTION_G_N_TO_G | FUNCTION_G_N_N_TO_G | FUNCTION_G_G_TO_G | FUNCTION_S_TO_N | FUNCTION_S_TO_S | FUNCTION_S_SPLUS_TO_S | FUNCTION_N_SPLUS_TO_S | FUNCTION_S_N1OR2_TO_S | FUNCTION_S_S_TO_N | FUNCTION_CLASSIF_NO_CLASS_NUMBER | FUNCTION_CLASSIF | FUNCTION_CLASSIF_CUSTOM | OMCOLUMNNAME | DATACOLUMNNAME | IF | NOT | LAND | LOR | ID | INT | FLOAT | COMMENT | WS | STRING );";
        }
    }
 

}