// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.xmltable;

public class Dtd {
    private void Dtd() { }
    
    public static String XMLTABLE_TAG = "xmltable";
    public static String HEAD_TAG = "head";
    public static String SOURCE_TAG = "source";
    public static String CONTENT_TAG = "content";
    public static String DATA_OBJECT_TAG = "dataObject";
    public static String DATA_TAG = "data";
    public static String GEOMETRY_TAG = "geometry";
    public static String THE_GEOM_TAG = "the_geom";
    public static String CENTROID_TAG = "centroid";
    public static String BOUNDING_BOX_TAG = "boundingBox";
    
    public static String NAME_ATTR = "name";
    
    /**
     * <code>type</code> attribute may be String, Double, Integer or gml.
     */
    public static String TYPE_ATTR = "type";
    
    // public static String _TAG = "";
    
}
