// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * RefreshableGUI.java
 *
 * Created on 11 juin 2007, 16:43
 *
 */

package fr.unicaen.openmap.event;

import fr.unicaen.openmap.dataStorage.DataStorageIterator;

/**
 * This interface must be used when an object can refresh itself
 * from a DataStorageIterator.
 *
 * @author davy
 */
public interface RefreshableGUI {
    public void refreshGUI(DataStorageIterator dsi);
}
