// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;

import com.bbn.openmap.Environment;
import com.bbn.openmap.I18n;
import com.bbn.openmap.MapHandler;
import com.bbn.openmap.gui.menu.MapHandlerMenuItem;

public class ExternalFrameMenuItem extends MapHandlerMenuItem{

		//private ThemaMapPanel themaMapPanel;
	    protected static I18n i18n = Environment.getI18n();
	    public final static String TITLE_PROPERTY_NAME = "title";

	    public  ExternalFrameMenuItem() {
	        super("Externalize");
	        setText(i18n.get(ExternalFrameMenuItem.class, TITLE_PROPERTY_NAME, "Externalize frames"));
	        addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	//themaMapPanel.externalize();
	            }
	        });
	    }
	    
	    
	    /*public void findAndInit(Object someObj) {
	    if (someObj instanceof ThemaMapPanel) {
	        setThemaMapPanel((ThemaMapPanel) someObj);
	    	}
	    }
	



		public ThemaMapPanel getThemaMapPanel() {
			return themaMapPanel;
		}


		public void setThemaMapPanel(ThemaMapPanel themaMapPanel) {
			this.themaMapPanel = themaMapPanel;
		}*/
}


