// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.gui.menu;
import java.io.File;
import javax.swing.filechooser.FileFilter;


/**
 *
 * @author Christophe Turbout@info.unicaen.fr, CERTIC, Université de Caen-Basse-Normandie, 2006.
 *  @deprecated
 */
public class PropertiesFileFilter extends FileFilter {

    public static final String  PROPERTIES = "properties";
    //Accept all directories and all sxw files.
    public boolean accept(File f){
        if (f.isDirectory()) 
            return true;
        
	return  f.getName().matches(".*\\."+PROPERTIES+"$");
    }

    //The description of this filter
    public String getDescription() {
        return "properties documents";
    }
}
