// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fr.unicaen.openmap.util.propertyEditor;

import java.util.Vector;
import fr.unicaen.openmap.util.propertyEditor.ComboBoxPropertyEditor;

public class QADifferenceModePropertyEditor extends ComboBoxPropertyEditor{

	protected void fill()
	{
		content = new Vector<String>()
		{
			{
				add( "Color" );
				add( "Area" );
			}
		};
	}

	public void setValue(Object string) {
		int value = 0;
		try
		{
			value = Integer.parseInt(""+string);
		}
		catch( NumberFormatException e )
		{
			super.setValue(string);
			return;
		}

		super.setValue( cBox.getItemAt( value-1 ) );
	}

	public String getAsText() {
			return ""+(cBox.getSelectedIndex()+1);
	}
}
